/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 86 "src/parse.yy"


#include "ispc.h"
#include "type.h"
#include "module.h"
#include "decl.h"
#include "expr.h"
#include "sym.h"
#include "stmt.h"
#include "util.h"

#include <stdio.h>
#include <llvm/IR/Constants.h>

#define UNIMPLEMENTED \
        Error(yylloc, "Unimplemented parser functionality %s:%d", \
        __FILE__, __LINE__);

union YYSTYPE;
extern int yylex();

extern char *yytext;

void yyerror(const char *s);

static int lYYTNameErr(char *yyres, const char *yystr);

static void lSuggestBuiltinAlternates();
static void lSuggestParamListAlternates();

static void lAddDeclaration(DeclSpecs *ds, Declarator *decl);
static void lAddFunctionParams(Declarator *decl);
static void lAddMaskToSymbolTable(SourcePos pos);
static void lAddThreadIndexCountToSymbolTable(SourcePos pos);
static std::string lGetAlternates(std::vector<std::string> &alternates);
static const char *lGetStorageClassString(StorageClass sc);
static bool lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage);
static EnumType *lCreateEnumType(const char *name, std::vector<Symbol *> *enums,
                                 SourcePos pos);
static void lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                                       const EnumType *enumType);

static const char *lBuiltinTokens[] = {
    "assert", "bool", "break", "case", "cdo",
    "cfor", "cif", "cwhile", "const", "continue", "default",
    "do", "delete", "double", "else", "enum", "export", "extern", "false",
    "float", "for", "foreach", "foreach_active", "foreach_tiled",
     "foreach_unique", "goto", "if", "in", "inline",
    "int", "int8", "int16", "int32", "int64", "launch", "new", "NULL",
    "print", "return", "signed", "sizeof", "static", "struct", "switch",
    "sync", "task", "true", "typedef", "uniform", "unmasked", "unsigned",
    "varying", "void", "while", NULL
};

static const char *lParamListTokens[] = {
    "bool", "const", "double", "enum", "false", "float", "int",
    "int8", "int16", "int32", "int64", "signed", "struct", "true",
    "uniform", "unsigned", "varying", "void", NULL
};

struct ForeachDimension {
    ForeachDimension(Symbol *s = NULL, Expr *b = NULL, Expr *e = NULL) {
        sym = s;
        beginExpr = b;
        endExpr = e;
    }
    Symbol *sym;
    Expr *beginExpr, *endExpr;
};


#line 143 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOKEN_INT8_CONSTANT = 3,        /* TOKEN_INT8_CONSTANT  */
  YYSYMBOL_TOKEN_UINT8_CONSTANT = 4,       /* TOKEN_UINT8_CONSTANT  */
  YYSYMBOL_TOKEN_INT16_CONSTANT = 5,       /* TOKEN_INT16_CONSTANT  */
  YYSYMBOL_TOKEN_UINT16_CONSTANT = 6,      /* TOKEN_UINT16_CONSTANT  */
  YYSYMBOL_TOKEN_INT32_CONSTANT = 7,       /* TOKEN_INT32_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32_CONSTANT = 8,      /* TOKEN_UINT32_CONSTANT  */
  YYSYMBOL_TOKEN_INT64_CONSTANT = 9,       /* TOKEN_INT64_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64_CONSTANT = 10,     /* TOKEN_UINT64_CONSTANT  */
  YYSYMBOL_TOKEN_INT32DOTDOTDOT_CONSTANT = 11, /* TOKEN_INT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32DOTDOTDOT_CONSTANT = 12, /* TOKEN_UINT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_INT64DOTDOTDOT_CONSTANT = 13, /* TOKEN_INT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64DOTDOTDOT_CONSTANT = 14, /* TOKEN_UINT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT_CONSTANT = 15,      /* TOKEN_FLOAT_CONSTANT  */
  YYSYMBOL_TOKEN_DOUBLE_CONSTANT = 16,     /* TOKEN_DOUBLE_CONSTANT  */
  YYSYMBOL_TOKEN_STRING_C_LITERAL = 17,    /* TOKEN_STRING_C_LITERAL  */
  YYSYMBOL_TOKEN_IDENTIFIER = 18,          /* TOKEN_IDENTIFIER  */
  YYSYMBOL_TOKEN_STRING_LITERAL = 19,      /* TOKEN_STRING_LITERAL  */
  YYSYMBOL_TOKEN_TYPE_NAME = 20,           /* TOKEN_TYPE_NAME  */
  YYSYMBOL_TOKEN_PRAGMA = 21,              /* TOKEN_PRAGMA  */
  YYSYMBOL_TOKEN_NULL = 22,                /* TOKEN_NULL  */
  YYSYMBOL_TOKEN_PTR_OP = 23,              /* TOKEN_PTR_OP  */
  YYSYMBOL_TOKEN_INC_OP = 24,              /* TOKEN_INC_OP  */
  YYSYMBOL_TOKEN_DEC_OP = 25,              /* TOKEN_DEC_OP  */
  YYSYMBOL_TOKEN_LEFT_OP = 26,             /* TOKEN_LEFT_OP  */
  YYSYMBOL_TOKEN_RIGHT_OP = 27,            /* TOKEN_RIGHT_OP  */
  YYSYMBOL_TOKEN_LE_OP = 28,               /* TOKEN_LE_OP  */
  YYSYMBOL_TOKEN_GE_OP = 29,               /* TOKEN_GE_OP  */
  YYSYMBOL_TOKEN_EQ_OP = 30,               /* TOKEN_EQ_OP  */
  YYSYMBOL_TOKEN_NE_OP = 31,               /* TOKEN_NE_OP  */
  YYSYMBOL_TOKEN_AND_OP = 32,              /* TOKEN_AND_OP  */
  YYSYMBOL_TOKEN_OR_OP = 33,               /* TOKEN_OR_OP  */
  YYSYMBOL_TOKEN_MUL_ASSIGN = 34,          /* TOKEN_MUL_ASSIGN  */
  YYSYMBOL_TOKEN_DIV_ASSIGN = 35,          /* TOKEN_DIV_ASSIGN  */
  YYSYMBOL_TOKEN_MOD_ASSIGN = 36,          /* TOKEN_MOD_ASSIGN  */
  YYSYMBOL_TOKEN_ADD_ASSIGN = 37,          /* TOKEN_ADD_ASSIGN  */
  YYSYMBOL_TOKEN_SUB_ASSIGN = 38,          /* TOKEN_SUB_ASSIGN  */
  YYSYMBOL_TOKEN_LEFT_ASSIGN = 39,         /* TOKEN_LEFT_ASSIGN  */
  YYSYMBOL_TOKEN_RIGHT_ASSIGN = 40,        /* TOKEN_RIGHT_ASSIGN  */
  YYSYMBOL_TOKEN_AND_ASSIGN = 41,          /* TOKEN_AND_ASSIGN  */
  YYSYMBOL_TOKEN_OR_ASSIGN = 42,           /* TOKEN_OR_ASSIGN  */
  YYSYMBOL_TOKEN_XOR_ASSIGN = 43,          /* TOKEN_XOR_ASSIGN  */
  YYSYMBOL_TOKEN_SIZEOF = 44,              /* TOKEN_SIZEOF  */
  YYSYMBOL_TOKEN_NEW = 45,                 /* TOKEN_NEW  */
  YYSYMBOL_TOKEN_DELETE = 46,              /* TOKEN_DELETE  */
  YYSYMBOL_TOKEN_IN = 47,                  /* TOKEN_IN  */
  YYSYMBOL_TOKEN_EXTERN = 48,              /* TOKEN_EXTERN  */
  YYSYMBOL_TOKEN_EXPORT = 49,              /* TOKEN_EXPORT  */
  YYSYMBOL_TOKEN_STATIC = 50,              /* TOKEN_STATIC  */
  YYSYMBOL_TOKEN_INLINE = 51,              /* TOKEN_INLINE  */
  YYSYMBOL_TOKEN_NOINLINE = 52,            /* TOKEN_NOINLINE  */
  YYSYMBOL_TOKEN_VECTORCALL = 53,          /* TOKEN_VECTORCALL  */
  YYSYMBOL_TOKEN_TASK = 54,                /* TOKEN_TASK  */
  YYSYMBOL_TOKEN_DECLSPEC = 55,            /* TOKEN_DECLSPEC  */
  YYSYMBOL_TOKEN_UNIFORM = 56,             /* TOKEN_UNIFORM  */
  YYSYMBOL_TOKEN_VARYING = 57,             /* TOKEN_VARYING  */
  YYSYMBOL_TOKEN_TYPEDEF = 58,             /* TOKEN_TYPEDEF  */
  YYSYMBOL_TOKEN_SOA = 59,                 /* TOKEN_SOA  */
  YYSYMBOL_TOKEN_UNMASKED = 60,            /* TOKEN_UNMASKED  */
  YYSYMBOL_TOKEN_CHAR = 61,                /* TOKEN_CHAR  */
  YYSYMBOL_TOKEN_INT = 62,                 /* TOKEN_INT  */
  YYSYMBOL_TOKEN_SIGNED = 63,              /* TOKEN_SIGNED  */
  YYSYMBOL_TOKEN_UNSIGNED = 64,            /* TOKEN_UNSIGNED  */
  YYSYMBOL_TOKEN_FLOAT = 65,               /* TOKEN_FLOAT  */
  YYSYMBOL_TOKEN_DOUBLE = 66,              /* TOKEN_DOUBLE  */
  YYSYMBOL_TOKEN_INT8 = 67,                /* TOKEN_INT8  */
  YYSYMBOL_TOKEN_INT16 = 68,               /* TOKEN_INT16  */
  YYSYMBOL_TOKEN_INT64 = 69,               /* TOKEN_INT64  */
  YYSYMBOL_TOKEN_CONST = 70,               /* TOKEN_CONST  */
  YYSYMBOL_TOKEN_VOID = 71,                /* TOKEN_VOID  */
  YYSYMBOL_TOKEN_BOOL = 72,                /* TOKEN_BOOL  */
  YYSYMBOL_TOKEN_UINT8 = 73,               /* TOKEN_UINT8  */
  YYSYMBOL_TOKEN_UINT16 = 74,              /* TOKEN_UINT16  */
  YYSYMBOL_TOKEN_UINT = 75,                /* TOKEN_UINT  */
  YYSYMBOL_TOKEN_UINT64 = 76,              /* TOKEN_UINT64  */
  YYSYMBOL_TOKEN_ENUM = 77,                /* TOKEN_ENUM  */
  YYSYMBOL_TOKEN_STRUCT = 78,              /* TOKEN_STRUCT  */
  YYSYMBOL_TOKEN_TRUE = 79,                /* TOKEN_TRUE  */
  YYSYMBOL_TOKEN_FALSE = 80,               /* TOKEN_FALSE  */
  YYSYMBOL_TOKEN_CASE = 81,                /* TOKEN_CASE  */
  YYSYMBOL_TOKEN_DEFAULT = 82,             /* TOKEN_DEFAULT  */
  YYSYMBOL_TOKEN_IF = 83,                  /* TOKEN_IF  */
  YYSYMBOL_TOKEN_ELSE = 84,                /* TOKEN_ELSE  */
  YYSYMBOL_TOKEN_SWITCH = 85,              /* TOKEN_SWITCH  */
  YYSYMBOL_TOKEN_WHILE = 86,               /* TOKEN_WHILE  */
  YYSYMBOL_TOKEN_DO = 87,                  /* TOKEN_DO  */
  YYSYMBOL_TOKEN_LAUNCH = 88,              /* TOKEN_LAUNCH  */
  YYSYMBOL_TOKEN_FOREACH = 89,             /* TOKEN_FOREACH  */
  YYSYMBOL_TOKEN_FOREACH_TILED = 90,       /* TOKEN_FOREACH_TILED  */
  YYSYMBOL_TOKEN_FOREACH_UNIQUE = 91,      /* TOKEN_FOREACH_UNIQUE  */
  YYSYMBOL_TOKEN_FOREACH_ACTIVE = 92,      /* TOKEN_FOREACH_ACTIVE  */
  YYSYMBOL_TOKEN_DOTDOTDOT = 93,           /* TOKEN_DOTDOTDOT  */
  YYSYMBOL_TOKEN_FOR = 94,                 /* TOKEN_FOR  */
  YYSYMBOL_TOKEN_GOTO = 95,                /* TOKEN_GOTO  */
  YYSYMBOL_TOKEN_CONTINUE = 96,            /* TOKEN_CONTINUE  */
  YYSYMBOL_TOKEN_BREAK = 97,               /* TOKEN_BREAK  */
  YYSYMBOL_TOKEN_RETURN = 98,              /* TOKEN_RETURN  */
  YYSYMBOL_TOKEN_CIF = 99,                 /* TOKEN_CIF  */
  YYSYMBOL_TOKEN_CDO = 100,                /* TOKEN_CDO  */
  YYSYMBOL_TOKEN_CFOR = 101,               /* TOKEN_CFOR  */
  YYSYMBOL_TOKEN_CWHILE = 102,             /* TOKEN_CWHILE  */
  YYSYMBOL_TOKEN_SYNC = 103,               /* TOKEN_SYNC  */
  YYSYMBOL_TOKEN_PRINT = 104,              /* TOKEN_PRINT  */
  YYSYMBOL_TOKEN_ASSERT = 105,             /* TOKEN_ASSERT  */
  YYSYMBOL_106_ = 106,                     /* '('  */
  YYSYMBOL_107_ = 107,                     /* ')'  */
  YYSYMBOL_108_ = 108,                     /* '['  */
  YYSYMBOL_109_ = 109,                     /* ']'  */
  YYSYMBOL_110_ = 110,                     /* ','  */
  YYSYMBOL_111_ = 111,                     /* '<'  */
  YYSYMBOL_112_ = 112,                     /* '>'  */
  YYSYMBOL_113_ = 113,                     /* '.'  */
  YYSYMBOL_114_ = 114,                     /* '&'  */
  YYSYMBOL_115_ = 115,                     /* '*'  */
  YYSYMBOL_116_ = 116,                     /* '+'  */
  YYSYMBOL_117_ = 117,                     /* '-'  */
  YYSYMBOL_118_ = 118,                     /* '~'  */
  YYSYMBOL_119_ = 119,                     /* '!'  */
  YYSYMBOL_120_ = 120,                     /* '/'  */
  YYSYMBOL_121_ = 121,                     /* '%'  */
  YYSYMBOL_122_ = 122,                     /* '^'  */
  YYSYMBOL_123_ = 123,                     /* '|'  */
  YYSYMBOL_124_ = 124,                     /* '?'  */
  YYSYMBOL_125_ = 125,                     /* ':'  */
  YYSYMBOL_126_ = 126,                     /* '='  */
  YYSYMBOL_127_ = 127,                     /* ';'  */
  YYSYMBOL_128_ = 128,                     /* '{'  */
  YYSYMBOL_129_ = 129,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 130,                 /* $accept  */
  YYSYMBOL_string_constant = 131,          /* string_constant  */
  YYSYMBOL_primary_expression = 132,       /* primary_expression  */
  YYSYMBOL_launch_expression = 133,        /* launch_expression  */
  YYSYMBOL_postfix_expression = 134,       /* postfix_expression  */
  YYSYMBOL_funcall_expression = 135,       /* funcall_expression  */
  YYSYMBOL_argument_expression_list = 136, /* argument_expression_list  */
  YYSYMBOL_unary_expression = 137,         /* unary_expression  */
  YYSYMBOL_cast_expression = 138,          /* cast_expression  */
  YYSYMBOL_multiplicative_expression = 139, /* multiplicative_expression  */
  YYSYMBOL_additive_expression = 140,      /* additive_expression  */
  YYSYMBOL_shift_expression = 141,         /* shift_expression  */
  YYSYMBOL_relational_expression = 142,    /* relational_expression  */
  YYSYMBOL_equality_expression = 143,      /* equality_expression  */
  YYSYMBOL_and_expression = 144,           /* and_expression  */
  YYSYMBOL_exclusive_or_expression = 145,  /* exclusive_or_expression  */
  YYSYMBOL_inclusive_or_expression = 146,  /* inclusive_or_expression  */
  YYSYMBOL_logical_and_expression = 147,   /* logical_and_expression  */
  YYSYMBOL_logical_or_expression = 148,    /* logical_or_expression  */
  YYSYMBOL_conditional_expression = 149,   /* conditional_expression  */
  YYSYMBOL_rate_qualified_new = 150,       /* rate_qualified_new  */
  YYSYMBOL_rate_qualified_type_specifier = 151, /* rate_qualified_type_specifier  */
  YYSYMBOL_new_expression = 152,           /* new_expression  */
  YYSYMBOL_assignment_expression = 153,    /* assignment_expression  */
  YYSYMBOL_expression = 154,               /* expression  */
  YYSYMBOL_constant_expression = 155,      /* constant_expression  */
  YYSYMBOL_declaration_statement = 156,    /* declaration_statement  */
  YYSYMBOL_declaration = 157,              /* declaration  */
  YYSYMBOL_soa_width_specifier = 158,      /* soa_width_specifier  */
  YYSYMBOL_declspec_item = 159,            /* declspec_item  */
  YYSYMBOL_declspec_list = 160,            /* declspec_list  */
  YYSYMBOL_declspec_specifier = 161,       /* declspec_specifier  */
  YYSYMBOL_declaration_specifiers = 162,   /* declaration_specifiers  */
  YYSYMBOL_init_declarator_list = 163,     /* init_declarator_list  */
  YYSYMBOL_init_declarator = 164,          /* init_declarator  */
  YYSYMBOL_storage_class_specifier = 165,  /* storage_class_specifier  */
  YYSYMBOL_type_specifier = 166,           /* type_specifier  */
  YYSYMBOL_type_specifier_list = 167,      /* type_specifier_list  */
  YYSYMBOL_atomic_var_type_specifier = 168, /* atomic_var_type_specifier  */
  YYSYMBOL_short_vec_specifier = 169,      /* short_vec_specifier  */
  YYSYMBOL_struct_or_union_name = 170,     /* struct_or_union_name  */
  YYSYMBOL_struct_or_union_and_name = 171, /* struct_or_union_and_name  */
  YYSYMBOL_struct_or_union_specifier = 172, /* struct_or_union_specifier  */
  YYSYMBOL_struct_or_union = 173,          /* struct_or_union  */
  YYSYMBOL_struct_declaration_list = 174,  /* struct_declaration_list  */
  YYSYMBOL_struct_declaration = 175,       /* struct_declaration  */
  YYSYMBOL_specifier_qualifier_list = 176, /* specifier_qualifier_list  */
  YYSYMBOL_struct_declarator_list = 177,   /* struct_declarator_list  */
  YYSYMBOL_struct_declarator = 178,        /* struct_declarator  */
  YYSYMBOL_enum_identifier = 179,          /* enum_identifier  */
  YYSYMBOL_enum_specifier = 180,           /* enum_specifier  */
  YYSYMBOL_enumerator_list = 181,          /* enumerator_list  */
  YYSYMBOL_enumerator = 182,               /* enumerator  */
  YYSYMBOL_type_qualifier = 183,           /* type_qualifier  */
  YYSYMBOL_type_qualifier_list = 184,      /* type_qualifier_list  */
  YYSYMBOL_declarator = 185,               /* declarator  */
  YYSYMBOL_int_constant = 186,             /* int_constant  */
  YYSYMBOL_direct_declarator = 187,        /* direct_declarator  */
  YYSYMBOL_pointer = 188,                  /* pointer  */
  YYSYMBOL_reference = 189,                /* reference  */
  YYSYMBOL_parameter_type_list = 190,      /* parameter_type_list  */
  YYSYMBOL_parameter_list = 191,           /* parameter_list  */
  YYSYMBOL_parameter_declaration = 192,    /* parameter_declaration  */
  YYSYMBOL_type_name = 193,                /* type_name  */
  YYSYMBOL_abstract_declarator = 194,      /* abstract_declarator  */
  YYSYMBOL_direct_abstract_declarator = 195, /* direct_abstract_declarator  */
  YYSYMBOL_initializer = 196,              /* initializer  */
  YYSYMBOL_initializer_list = 197,         /* initializer_list  */
  YYSYMBOL_pragma = 198,                   /* pragma  */
  YYSYMBOL_attributed_statement = 199,     /* attributed_statement  */
  YYSYMBOL_statement = 200,                /* statement  */
  YYSYMBOL_labeled_statement = 201,        /* labeled_statement  */
  YYSYMBOL_start_scope = 202,              /* start_scope  */
  YYSYMBOL_end_scope = 203,                /* end_scope  */
  YYSYMBOL_compound_statement = 204,       /* compound_statement  */
  YYSYMBOL_statement_list = 205,           /* statement_list  */
  YYSYMBOL_expression_statement = 206,     /* expression_statement  */
  YYSYMBOL_selection_statement = 207,      /* selection_statement  */
  YYSYMBOL_for_test = 208,                 /* for_test  */
  YYSYMBOL_for_init_statement = 209,       /* for_init_statement  */
  YYSYMBOL_for_scope = 210,                /* for_scope  */
  YYSYMBOL_cfor_scope = 211,               /* cfor_scope  */
  YYSYMBOL_foreach_scope = 212,            /* foreach_scope  */
  YYSYMBOL_foreach_tiled_scope = 213,      /* foreach_tiled_scope  */
  YYSYMBOL_foreach_identifier = 214,       /* foreach_identifier  */
  YYSYMBOL_foreach_active_scope = 215,     /* foreach_active_scope  */
  YYSYMBOL_foreach_active_identifier = 216, /* foreach_active_identifier  */
  YYSYMBOL_integer_dotdotdot = 217,        /* integer_dotdotdot  */
  YYSYMBOL_foreach_dimension_specifier = 218, /* foreach_dimension_specifier  */
  YYSYMBOL_foreach_dimension_list = 219,   /* foreach_dimension_list  */
  YYSYMBOL_foreach_unique_scope = 220,     /* foreach_unique_scope  */
  YYSYMBOL_foreach_unique_identifier = 221, /* foreach_unique_identifier  */
  YYSYMBOL_iteration_statement = 222,      /* iteration_statement  */
  YYSYMBOL_223_1 = 223,                    /* $@1  */
  YYSYMBOL_224_2 = 224,                    /* $@2  */
  YYSYMBOL_225_3 = 225,                    /* $@3  */
  YYSYMBOL_226_4 = 226,                    /* $@4  */
  YYSYMBOL_goto_identifier = 227,          /* goto_identifier  */
  YYSYMBOL_jump_statement = 228,           /* jump_statement  */
  YYSYMBOL_sync_statement = 229,           /* sync_statement  */
  YYSYMBOL_delete_statement = 230,         /* delete_statement  */
  YYSYMBOL_unmasked_statement = 231,       /* unmasked_statement  */
  YYSYMBOL_print_statement = 232,          /* print_statement  */
  YYSYMBOL_assert_statement = 233,         /* assert_statement  */
  YYSYMBOL_translation_unit = 234,         /* translation_unit  */
  YYSYMBOL_external_declaration = 235,     /* external_declaration  */
  YYSYMBOL_function_definition = 236,      /* function_definition  */
  YYSYMBOL_237_5 = 237                     /* $@5  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  81
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3487

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  130
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  108
/* YYNRULES -- Number of rules.  */
#define YYNRULES  346
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  651

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   360


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,     2,     2,     2,   121,   114,     2,
     106,   107,   115,   116,   110,   117,   113,   120,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   125,   127,
     111,   126,   112,   124,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   108,     2,   109,   122,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   128,   123,   129,   118,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   279,   279,   280,   289,   308,   312,   316,   320,   324,
     328,   332,   336,   340,   344,   348,   351,   354,   359,   360,
     364,   370,   377,   383,   390,   396,   402,   408,   415,   420,
     425,   430,   437,   443,   449,   455,   464,   465,   467,   469,
     470,   472,   474,   476,   481,   482,   484,   486,   491,   492,
     506,   507,   509,   511,   513,   515,   517,   519,   521,   523,
     525,   530,   531,   538,   539,   541,   543,   548,   549,   551,
     556,   557,   559,   564,   565,   567,   569,   571,   576,   577,
     579,   584,   585,   590,   591,   596,   597,   602,   603,   608,
     609,   614,   615,   620,   621,   622,   626,   627,   638,   649,
     673,   674,   678,   682,   689,   690,   692,   694,   696,   698,
     700,   702,   704,   706,   708,   710,   715,   716,   721,   725,
     751,   755,   762,   767,   777,   782,   791,   798,   802,   816,
     822,   832,   838,   849,   853,   859,   877,   881,   891,   898,
     912,   913,   922,   923,   924,   925,   929,   930,   935,   936,
     940,   951,   962,   963,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   973,   977,   984,   985,   989,  1011,  1012,
    1031,  1045,  1053,  1070,  1074,  1081,  1095,  1100,  1101,  1102,
    1103,  1184,  1191,  1205,  1213,  1216,  1220,  1224,  1228,  1232,
    1255,  1265,  1279,  1283,  1299,  1300,  1301,  1302,  1303,  1304,
    1305,  1306,  1307,  1308,  1309,  1313,  1317,  1324,  1336,  1348,
    1352,  1353,  1354,  1355,  1359,  1365,  1369,  1387,  1398,  1402,
    1414,  1424,  1432,  1436,  1442,  1448,  1459,  1467,  1471,  1478,
    1487,  1495,  1499,  1508,  1515,  1532,  1533,  1545,  1549,  1550,
    1560,  1564,  1577,  1579,  1585,  1602,  1613,  1631,  1633,  1639,
    1649,  1663,  1664,  1665,  1669,  1671,  1685,  1692,  1700,  1704,
    1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,
    1715,  1716,  1724,  1728,  1738,  1743,  1747,  1751,  1752,  1756,
    1762,  1775,  1776,  1780,  1782,  1784,  1786,  1788,  1793,  1795,
    1800,  1801,  1805,  1809,  1813,  1817,  1821,  1828,  1832,  1839,
    1843,  1847,  1851,  1858,  1862,  1869,  1874,  1888,  1892,  1896,
    1898,  1900,  1902,  1904,  1908,  1912,  1916,  1921,  1920,  1949,
    1948,  1978,  1977,  1989,  1987,  2008,  2012,  2014,  2016,  2018,
    2020,  2025,  2030,  2037,  2044,  2048,  2055,  2062,  2063,  2064,
    2068,  2069,  2070,  2075,  2081,  2086,  2085
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOKEN_INT8_CONSTANT",
  "TOKEN_UINT8_CONSTANT", "TOKEN_INT16_CONSTANT", "TOKEN_UINT16_CONSTANT",
  "TOKEN_INT32_CONSTANT", "TOKEN_UINT32_CONSTANT", "TOKEN_INT64_CONSTANT",
  "TOKEN_UINT64_CONSTANT", "TOKEN_INT32DOTDOTDOT_CONSTANT",
  "TOKEN_UINT32DOTDOTDOT_CONSTANT", "TOKEN_INT64DOTDOTDOT_CONSTANT",
  "TOKEN_UINT64DOTDOTDOT_CONSTANT", "TOKEN_FLOAT_CONSTANT",
  "TOKEN_DOUBLE_CONSTANT", "TOKEN_STRING_C_LITERAL", "TOKEN_IDENTIFIER",
  "TOKEN_STRING_LITERAL", "TOKEN_TYPE_NAME", "TOKEN_PRAGMA", "TOKEN_NULL",
  "TOKEN_PTR_OP", "TOKEN_INC_OP", "TOKEN_DEC_OP", "TOKEN_LEFT_OP",
  "TOKEN_RIGHT_OP", "TOKEN_LE_OP", "TOKEN_GE_OP", "TOKEN_EQ_OP",
  "TOKEN_NE_OP", "TOKEN_AND_OP", "TOKEN_OR_OP", "TOKEN_MUL_ASSIGN",
  "TOKEN_DIV_ASSIGN", "TOKEN_MOD_ASSIGN", "TOKEN_ADD_ASSIGN",
  "TOKEN_SUB_ASSIGN", "TOKEN_LEFT_ASSIGN", "TOKEN_RIGHT_ASSIGN",
  "TOKEN_AND_ASSIGN", "TOKEN_OR_ASSIGN", "TOKEN_XOR_ASSIGN",
  "TOKEN_SIZEOF", "TOKEN_NEW", "TOKEN_DELETE", "TOKEN_IN", "TOKEN_EXTERN",
  "TOKEN_EXPORT", "TOKEN_STATIC", "TOKEN_INLINE", "TOKEN_NOINLINE",
  "TOKEN_VECTORCALL", "TOKEN_TASK", "TOKEN_DECLSPEC", "TOKEN_UNIFORM",
  "TOKEN_VARYING", "TOKEN_TYPEDEF", "TOKEN_SOA", "TOKEN_UNMASKED",
  "TOKEN_CHAR", "TOKEN_INT", "TOKEN_SIGNED", "TOKEN_UNSIGNED",
  "TOKEN_FLOAT", "TOKEN_DOUBLE", "TOKEN_INT8", "TOKEN_INT16",
  "TOKEN_INT64", "TOKEN_CONST", "TOKEN_VOID", "TOKEN_BOOL", "TOKEN_UINT8",
  "TOKEN_UINT16", "TOKEN_UINT", "TOKEN_UINT64", "TOKEN_ENUM",
  "TOKEN_STRUCT", "TOKEN_TRUE", "TOKEN_FALSE", "TOKEN_CASE",
  "TOKEN_DEFAULT", "TOKEN_IF", "TOKEN_ELSE", "TOKEN_SWITCH", "TOKEN_WHILE",
  "TOKEN_DO", "TOKEN_LAUNCH", "TOKEN_FOREACH", "TOKEN_FOREACH_TILED",
  "TOKEN_FOREACH_UNIQUE", "TOKEN_FOREACH_ACTIVE", "TOKEN_DOTDOTDOT",
  "TOKEN_FOR", "TOKEN_GOTO", "TOKEN_CONTINUE", "TOKEN_BREAK",
  "TOKEN_RETURN", "TOKEN_CIF", "TOKEN_CDO", "TOKEN_CFOR", "TOKEN_CWHILE",
  "TOKEN_SYNC", "TOKEN_PRINT", "TOKEN_ASSERT", "'('", "')'", "'['", "']'",
  "','", "'<'", "'>'", "'.'", "'&'", "'*'", "'+'", "'-'", "'~'", "'!'",
  "'/'", "'%'", "'^'", "'|'", "'?'", "':'", "'='", "';'", "'{'", "'}'",
  "$accept", "string_constant", "primary_expression", "launch_expression",
  "postfix_expression", "funcall_expression", "argument_expression_list",
  "unary_expression", "cast_expression", "multiplicative_expression",
  "additive_expression", "shift_expression", "relational_expression",
  "equality_expression", "and_expression", "exclusive_or_expression",
  "inclusive_or_expression", "logical_and_expression",
  "logical_or_expression", "conditional_expression", "rate_qualified_new",
  "rate_qualified_type_specifier", "new_expression",
  "assignment_expression", "expression", "constant_expression",
  "declaration_statement", "declaration", "soa_width_specifier",
  "declspec_item", "declspec_list", "declspec_specifier",
  "declaration_specifiers", "init_declarator_list", "init_declarator",
  "storage_class_specifier", "type_specifier", "type_specifier_list",
  "atomic_var_type_specifier", "short_vec_specifier",
  "struct_or_union_name", "struct_or_union_and_name",
  "struct_or_union_specifier", "struct_or_union",
  "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_identifier", "enum_specifier",
  "enumerator_list", "enumerator", "type_qualifier", "type_qualifier_list",
  "declarator", "int_constant", "direct_declarator", "pointer",
  "reference", "parameter_type_list", "parameter_list",
  "parameter_declaration", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "pragma", "attributed_statement", "statement", "labeled_statement",
  "start_scope", "end_scope", "compound_statement", "statement_list",
  "expression_statement", "selection_statement", "for_test",
  "for_init_statement", "for_scope", "cfor_scope", "foreach_scope",
  "foreach_tiled_scope", "foreach_identifier", "foreach_active_scope",
  "foreach_active_identifier", "integer_dotdotdot",
  "foreach_dimension_specifier", "foreach_dimension_list",
  "foreach_unique_scope", "foreach_unique_identifier",
  "iteration_statement", "$@1", "$@2", "$@3", "$@4", "goto_identifier",
  "jump_statement", "sync_statement", "delete_statement",
  "unmasked_statement", "print_statement", "assert_statement",
  "translation_unit", "external_declaration", "function_definition", "$@5", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    40,    41,    91,    93,
      44,    60,    62,    46,    38,    42,    43,    45,   126,    33,
      47,    37,    94,   124,    63,    58,    61,    59,   123,   125
};
#endif

#define YYPACT_NINF (-300)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-346)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     951,  -108,  -300,    36,    87,  -300,  -300,  -300,  -300,  -300,
     -83,  -300,  -300,  -300,   -44,  -300,  -300,  -300,  -300,  -300,
    -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,
    -300,     6,  -300,  -300,  -300,  3368,  3368,   108,  3368,  3304,
    -300,    90,  -300,    11,  -300,  3368,   497,  -300,  -300,  -300,
      97,   691,   165,   248,  -300,   216,   111,    68,  -300,  -300,
    -300,  -300,    31,  -300,   528,  -300,   -71,  -300,   -29,   -43,
      12,    12,  -300,   248,  -300,  2925,  -300,  -300,  2955,  -300,
    -300,  -300,  -300,  3368,  -300,   -75,  -300,  -300,    70,  -300,
    -300,  -300,  -300,   142,    14,   -65,  -300,   216,  -300,   153,
    -300,   528,  -300,    31,  -300,  1052,   180,  3184,  1687,   -43,
     -43,   173,  -300,  3409,   229,  -300,  2993,  -300,    31,  3409,
    -300,  3023,   194,   108,   691,   201,  -300,   165,  -300,  2654,
      -2,  -300,   -60,  -300,  -300,  -300,  -300,   222,  -300,  -300,
    -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,
    2677,  2677,  2700,  -300,   310,   319,  -300,  -300,  3099,  1425,
    2677,  2677,  2654,  2654,  2654,  2654,  1052,  -300,  -300,   187,
    -300,   239,  -300,    21,   -40,   218,     5,   240,   236,   235,
     247,   355,    -5,  -300,  1327,  -300,  -300,  -300,   270,   859,
    -300,   109,  -300,    64,   297,   314,  -300,   318,  -300,  -300,
    -300,   321,  -300,  -300,   248,  -300,  -300,   -27,  -300,  -300,
    -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,     3,
    -300,  1556,  -300,  -300,  1425,  -300,  -300,  -300,  2470,  2861,
     203,   326,   310,   319,  -300,   122,   135,   334,  -300,  -300,
    -300,  -300,  -300,  -300,  -300,   -59,   425,  -300,  -300,  1511,
    1642,   435,  2470,  2470,  2470,  2470,  2470,  2470,  2470,  2470,
    2470,  2470,  2470,  2654,  2654,  2654,  2654,  2654,  2654,  2654,
    2654,  2654,  2654,  2654,  2654,  2654,  2654,  2654,  2654,  2654,
    2654,  2470,   691,   691,    67,   691,  -300,  -300,   336,   342,
    -300,  2470,   343,  2654,   349,   370,   381,   382,   859,  -300,
    -300,  -300,  -300,  -300,   471,   363,   364,  1255,   386,   859,
    -300,   387,   367,   389,   390,  -300,    33,  -300,  -300,   859,
    -300,  -300,  -300,  -300,   601,  -300,  -300,   392,   393,   395,
     396,   397,   398,  -300,   380,  -300,  -300,  -300,  -300,  -300,
    -300,  -300,  -300,  2780,  2513,   383,     0,     0,  -300,   206,
    -300,  3368,  -300,  -300,   400,    31,  -300,  -300,   401,   312,
     213,  1815,  -300,  -300,  2470,  2858,   212,   212,  -300,  2654,
    1027,  -300,  -300,   403,  -300,   157,  -300,   404,   341,  -300,
    -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,
    -300,  -300,  -300,  -300,    21,    21,   -40,   -40,   218,   218,
     218,   218,     5,     5,   240,   236,   235,   247,   355,    51,
    -300,  -300,  1052,  2470,  -300,  -300,    55,   859,   391,   859,
    2470,  2470,  2470,   428,  -300,   388,  -300,  -300,  -300,    57,
    2470,   433,  2470,  -300,   488,   488,  -300,  -300,  -300,  -300,
    -300,  1169,  1169,   502,   502,   504,   507,   859,   416,  -300,
     426,   431,  -300,   422,  1052,   206,   206,  3244,  2537,  -300,
    -300,  -300,  -300,  3120,  2470,  1860,  -300,   159,  -300,  -300,
    -300,  -300,  -300,  -300,  2470,  -300,  -300,  2654,   182,   346,
    -300,   730,   859,  -300,   184,   191,   192,   429,  -300,  -300,
     215,   434,   217,  -300,    52,    25,  -300,  -300,  1300,  1300,
    -300,   413,  -300,   225,   251,  -300,   437,  -300,   495,  -300,
    -300,  -300,  -300,  -300,  -300,   451,  -300,   467,  2470,  2861,
     223,   348,   466,   256,  -300,  -300,  -300,  -300,  1052,  -300,
    -300,  -300,   859,   859,   859,  2470,   859,  2470,   859,  -300,
     459,  2470,  2470,  -300,   103,  1946,  1991,  1729,  -300,   502,
    -300,  -300,  2470,  -300,  -300,   478,   238,  2077,  2861,  2470,
    -300,   477,   506,  -300,  -300,   261,   509,   265,  -300,  -300,
     267,   269,  -300,   859,   282,   859,   286,  -300,  -300,  -300,
    -300,   501,  2470,   859,  -300,   859,   859,   287,  1773,  2122,
    -300,   288,   360,   486,  -300,   859,   469,   859,   470,   472,
     473,  -300,   859,  -300,   859,  2470,  -300,  -300,  -300,  -300,
    -300,  2470,   415,   489,   296,  -300,  2208,  2861,  -300,  -300,
    -300,  -300,  -300,  -300,  -300,  -300,  -300,   859,   494,  2253,
    -300,   500,  -300,   301,   421,  -300,  2861,  -300,   305,  -300,
    -300,  2339,   424,  -300,  -300,   307,  2384,  -300,  -300,   309,
    -300
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   147,   143,   199,   145,   200,   201,   202,   197,
       0,   195,   196,   142,     0,   198,   158,   203,   204,   160,
     161,   154,   156,   162,   194,   152,   153,   155,   157,   159,
     163,     0,   173,   344,   343,   131,   129,     0,   127,   133,
     146,   168,   148,     0,   149,   136,     0,   337,   340,   339,
     144,     0,     0,     0,   184,     0,   189,   143,   199,   132,
     130,   214,     0,   226,   222,   120,     0,   138,   140,   209,
       0,     0,   128,     0,   135,     0,   165,   166,     0,   167,
     137,     1,   338,     0,   150,     0,   123,   124,     0,   210,
     211,   212,   213,     0,   192,     0,   190,     0,   144,     0,
     205,   223,   224,     0,   121,     0,     0,     0,     0,   207,
     208,     0,   172,   178,   146,   179,     0,   174,     0,     0,
     171,     0,     0,     0,     0,     0,   126,     0,   122,     0,
       0,   185,     0,   215,   206,   225,   139,   140,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,     4,    17,
       0,     0,     0,    93,     0,     0,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,    39,    44,
      50,    61,    63,    67,    70,    73,    78,    81,    83,    85,
      87,    89,    91,   100,     0,   104,   251,   141,   275,     0,
     346,     0,   220,   234,     0,   227,   228,     0,   217,    61,
     118,     0,   134,   177,     0,   169,   175,     0,   181,   183,
     180,   170,   341,   151,   342,   125,   193,   187,   191,     0,
     186,     0,    51,    52,     0,    59,    94,    95,     0,     0,
       0,     0,   195,   196,   116,     0,   235,     0,    53,    54,
      55,    56,    57,    58,   254,     0,     0,    42,    43,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   101,     0,    96,   277,     0,     4,
     256,     0,   198,     0,     0,     0,     0,     0,     0,   294,
     295,   307,   297,   292,     0,     0,     0,     0,     0,     0,
     293,     0,     0,     0,     0,   281,     0,   265,   119,     0,
     279,   258,   259,   260,     0,   261,   262,     0,     0,     0,
       0,     0,     0,   263,     0,   264,   268,   269,   270,   266,
     267,   221,   230,     0,     0,   231,   237,   240,   233,   238,
     219,     0,   218,   216,     0,     0,   176,   188,     0,     0,
       0,     0,    19,    18,     0,     0,   237,   240,   236,     0,
       0,   252,    41,     0,    45,     0,    48,     0,     0,    40,
     106,   107,   108,   109,   110,   111,   112,   113,   115,   114,
     105,    64,    65,    66,    68,    69,    71,    72,    76,    77,
      74,    75,    79,    80,    82,    84,    86,    88,    90,     0,
      97,    98,     0,     0,    99,   271,     0,     0,     0,     0,
       0,     0,     0,     0,   325,     0,   327,   328,   329,     0,
       0,     0,     0,   331,     0,     0,   282,   257,   276,   280,
     278,     0,     0,     0,     0,     0,     0,     0,     0,   247,
       0,     0,   243,     0,     0,   239,   241,     0,     0,   229,
     164,   182,    60,     0,     0,     0,    21,     0,   117,    62,
     253,   255,    47,    46,     0,    38,    37,     0,     0,     0,
     332,     0,     0,   274,     0,     0,     0,     0,   326,   330,
       0,     0,     0,     2,     0,     0,   291,   290,     0,     0,
     296,     0,   305,     0,     0,   298,     0,   308,     0,   272,
     248,   242,   244,   232,   249,     0,   245,     0,     0,     0,
       0,     0,     0,     0,    20,    49,    92,   102,     0,   103,
     333,   273,     0,     0,     0,     0,     0,     0,     0,     3,
       0,     0,     0,   288,     0,     0,     0,     0,   317,     0,
     319,   321,     0,   250,   246,     0,     0,     0,     0,     0,
      33,     0,   283,   287,   309,     0,   285,     0,   310,   334,
       0,     0,   289,     0,     0,     0,     0,   299,   300,   301,
     302,     0,     0,     0,   306,     0,     0,     0,     0,     0,
      23,     0,     0,     0,    32,     0,     0,     0,     0,     0,
       0,   313,     0,   315,     0,     0,   304,   318,   320,   322,
     323,     0,     0,     0,     0,    22,     0,     0,   284,   311,
     286,   312,   335,   336,   314,   316,   303,     0,     0,     0,
      35,     0,    25,     0,     0,   324,     0,    27,     0,    34,
      24,     0,     0,    26,    29,     0,     0,    28,    31,     0,
      30
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -300,   178,  -300,  -300,  -157,  -300,  -299,   -72,  -152,   195,
     196,   -85,   207,   338,   350,   337,   339,   340,  -300,  -104,
    -300,  -300,  -300,  -105,  -117,  -124,    28,    22,   444,   503,
    -300,  -300,     2,  -300,   526,  -300,   359,  -300,   -61,  -300,
    -300,  -300,  -300,  -300,   553,    -1,   -93,  -300,   277,   602,
    -300,   537,   -98,     9,  -300,   -22,   -46,   -63,   -55,  -134,
    -101,  -300,   284,   412,  -150,  -272,  -102,   226,  -300,  -195,
    -300,  -300,  -300,  -300,   531,   231,    44,  -300,   140,   198,
    -300,  -300,  -300,  -300,  -300,  -300,  -300,  -300,   113,   241,
    -300,  -300,  -300,  -300,  -300,  -300,  -300,   405,  -300,  -300,
    -300,  -300,  -300,  -300,  -300,   648,  -300,  -300
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   494,   167,   168,   169,   170,   375,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   284,   185,   234,   316,   201,   317,   318,    35,    87,
      88,    36,   123,    66,    67,    38,    39,    85,    40,   115,
      79,    41,    42,    43,   116,   117,   118,   207,   208,    94,
      44,    95,    96,    45,   101,    99,    93,    69,    70,    71,
     450,   195,   196,   237,   451,   349,   244,   245,   319,   320,
     321,   322,   189,   440,   323,   324,   325,   326,   545,   498,
     327,   328,   329,   330,   501,   331,   506,   582,   502,   503,
     332,   508,   333,   583,   585,   586,   627,   334,   335,   336,
     337,   338,   339,   340,    46,    47,    48,   106
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     186,   230,    37,   187,   200,   216,   194,   109,   110,   102,
     240,   241,   242,   243,   114,    68,    54,   114,    61,    49,
     203,    54,    34,    52,    54,   200,   210,   111,   280,    76,
      61,    77,   218,   270,   271,   124,   199,    59,    60,   103,
      72,    74,   235,   348,   539,   130,   135,    80,    37,    61,
     219,   370,   114,    50,   125,   114,   104,   199,   114,   347,
     114,   186,   467,   107,   131,   108,   236,    53,    34,   220,
     371,   539,   360,   100,   455,   456,   266,   267,   222,   223,
     225,   137,    61,   355,   119,    98,   368,   119,   238,   239,
     199,   199,   199,   199,   455,   456,   209,   105,   114,  -345,
     356,   137,   367,   423,   235,   122,   343,   235,   344,   193,
     134,   391,   392,   393,   431,   206,   272,   273,    62,   281,
     206,   218,   119,   359,   437,   119,    61,   217,   119,   439,
     119,   236,   357,   378,    55,   542,   263,    62,   346,    78,
     129,   264,   265,   364,   376,    63,    64,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   354,   540,
     436,   364,   541,   114,   409,   364,   523,   364,   119,   418,
     343,   345,   344,   412,   416,   413,   477,   126,    63,    64,
     127,   366,   480,    86,   489,   398,   399,   400,   401,   200,
     429,   199,   199,   199,   199,   199,   199,   199,   199,   199,
     199,   199,   199,   199,   199,   199,   199,   199,   199,   347,
     246,   247,   248,   364,    62,    51,   341,   469,    75,   342,
     453,   199,    63,    64,   483,    83,   246,   247,   248,   363,
     572,   367,   364,   119,    54,    65,   246,   247,   248,    97,
     200,   365,   570,   344,   268,   269,   246,   247,   248,    63,
      64,    89,   509,    90,   128,    91,   376,    92,   591,   468,
     133,   246,   247,   248,   473,   186,   524,   474,   471,   474,
     274,   275,   199,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   109,   110,   202,   439,   531,   346,   527,
     614,   532,   528,   249,   364,   250,   479,   199,   533,   534,
     251,   364,   364,   484,   485,   486,   520,   186,   188,   361,
     366,   250,   457,   490,   458,   492,   251,   633,   365,   465,
     344,   250,   536,   212,   538,   364,   251,   364,   214,   557,
     638,   250,   548,   209,   517,   549,   251,   562,   563,   564,
     204,   566,   645,   568,   589,   193,   250,   649,   105,   186,
     276,   251,   513,   193,   200,   226,   515,   277,   550,   521,
     376,   549,   556,   561,   227,   262,   474,   193,   596,   525,
     278,   364,   598,   526,   599,   364,   600,   474,   601,   364,
     603,   544,   544,   246,   247,   248,   199,   279,   607,   602,
     608,   609,   364,   604,   610,   615,   364,   364,   474,   287,
     618,   592,   620,   631,   350,   199,   474,   624,   640,   625,
      84,   474,   643,   555,   647,   474,   650,   474,   565,   474,
     567,   463,   464,   186,   351,   571,   471,   352,   574,   576,
     353,   612,   635,   362,   113,   587,   376,   113,   246,   247,
     248,   369,   581,   372,   246,   247,   248,   246,   247,   248,
     476,   364,   376,   379,   593,   529,   364,   558,   559,   193,
     634,   394,   395,   415,   396,   397,   616,  -325,   250,   496,
     496,   417,   113,   251,   419,   113,   420,   606,   113,   642,
     113,   402,   403,   213,   376,   497,   497,   421,   422,   424,
     426,   427,   430,   432,   433,   434,   435,    81,   441,   442,
     626,   443,   444,   445,   446,   447,   628,   493,   462,   454,
     472,   376,   460,   475,   487,   488,   482,     2,   113,   491,
     500,   629,   505,   250,   376,   507,   342,   641,   251,   250,
     646,   512,   250,   510,   251,   535,   376,   251,   511,   547,
     537,   376,   552,   286,   551,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,   553,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,   554,    58,   560,     6,
       7,     8,     9,   113,    11,    12,   569,   588,    15,   594,
     595,    17,    18,   597,   605,   617,   619,   621,    24,   622,
     623,   630,   288,   636,   138,   139,   140,   141,   142,   143,
     144,   145,   639,   495,   404,   406,   146,   147,   407,   289,
     408,     2,   290,   149,    33,   150,   151,   405,   285,   136,
     215,   121,   461,    56,   132,   459,   358,   190,   478,   546,
     499,   410,   411,    64,   414,   152,   153,   291,   481,    57,
      58,     5,     6,     7,     8,     9,    10,   232,   233,    13,
      14,   292,   584,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
     156,   157,   293,   294,   295,   504,   296,   297,   298,   158,
     299,   300,   301,   302,    82,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   159,     0,   425,
       0,     2,     0,     0,     0,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,     0,   315,   188,
     438,   288,     0,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   289,     0,
       2,   290,   149,    16,   150,   151,    19,    20,    21,    22,
      23,     0,    25,    26,    27,    28,    29,    30,    31,    32,
       0,     0,     0,     0,   152,   153,   291,     0,    57,    58,
       5,     6,     7,     8,     9,    10,   232,   233,    13,    14,
     292,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,   156,
     157,   293,   294,   295,     0,   296,   297,   298,   158,   299,
     300,   301,   302,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   159,     0,     0,     0,
       0,     0,     0,     0,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,     0,   315,   188,   530,
     288,     0,   138,   139,   140,   141,   142,   143,   144,   145,
       0,     0,     0,     0,   146,   147,     0,   289,     0,     2,
     290,   149,     0,   150,   151,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   152,   153,   291,     0,    57,    58,     5,
       6,     7,     8,     9,    10,   232,   233,    13,    14,   292,
       0,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,   156,   157,
     293,   294,   295,     0,   296,   297,   298,   158,   299,   300,
     301,   302,     1,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   159,     0,     0,     0,     0,
       0,     2,     0,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,     0,   315,   188,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,     0,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
     138,   139,   140,   141,   142,   143,   144,   145,     0,     0,
       0,     0,   146,   147,     0,   148,     0,     0,     0,   149,
       0,   150,   151,     0,     0,   138,   139,   140,   141,   142,
     143,   144,   145,     0,     0,     0,     0,   146,   147,     0,
     148,   152,   153,     0,   149,     0,   150,   151,    33,     0,
       0,     0,     0,   154,   155,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   152,   153,     0,     0,
       0,     0,     0,     0,     0,     0,   156,   157,   154,   155,
       0,     0,     0,     0,     0,   158,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   156,   157,   159,     0,     0,     0,     0,     0,     0,
     158,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,     0,     0,   166,   470,     0,   159,     0,
       0,     0,     0,     0,     0,     0,   160,   161,   162,   163,
     164,   165,   138,   139,   140,   141,   142,   143,   144,   145,
     166,     0,     0,     0,   146,   147,     0,   148,     0,     2,
       0,   149,     0,   150,   151,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   152,   153,     0,     0,    57,    58,     5,
       6,     7,     8,     9,    10,   232,   233,    13,    14,    15,
       0,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,   156,   157,
       0,     0,     0,     0,     0,     0,     0,   158,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
     146,   147,     0,   148,     0,   159,     0,   149,     0,   150,
     151,     0,     0,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,     0,   315,     0,     0,   152,
     153,     0,     0,   138,   139,   140,   141,   142,   143,   144,
     145,   154,   155,     0,     0,   146,   147,     0,   148,     0,
       0,     0,   149,     0,   150,   151,     0,     0,     0,     0,
       0,     0,     0,     0,   156,   157,     0,     0,     0,     0,
       0,     0,     0,   158,   152,   153,     0,     2,     0,     0,
       0,     0,     0,     0,     0,     0,   154,   155,     0,     0,
       0,   159,     0,     0,     0,     0,     0,     0,     0,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,   156,
     157,     0,   428,   282,   283,     0,    14,     0,   158,    16,
       0,     0,    19,    20,    21,    22,    23,     0,    25,    26,
      27,    28,    29,    30,    31,    32,   159,     0,     0,     0,
       0,     0,     0,     0,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,   231,   543,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
     146,   147,     0,   148,     0,     2,     0,   149,     0,   150,
     151,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
     153,     0,     0,     0,    58,     0,     6,     7,     8,     9,
       0,   232,   233,     0,     0,    15,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,   156,   157,     0,     0,     0,     0,
       0,     0,   373,   158,   138,   139,   140,   141,   142,   143,
     144,   145,     0,     0,     0,     0,   146,   147,     0,   148,
       0,   159,     0,   149,     0,   150,   151,     0,     0,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   152,   153,   231,     0,   138,
     139,   140,   141,   142,   143,   144,   145,   154,   155,     0,
       0,   146,   147,     0,   148,     0,     0,     0,   149,     0,
     150,   151,     0,     0,     0,     0,     0,     0,     0,     0,
     156,   157,     0,     0,     0,     0,     0,     0,     0,   158,
     152,   153,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   154,   155,     0,     0,     0,   159,   374,     0,
       0,     0,     0,     0,     0,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,   156,   157,     0,     0,     0,
       0,     0,     0,   377,   158,   138,   139,   140,   141,   142,
     143,   144,   145,     0,     0,     0,     0,   146,   147,     0,
     148,     0,   159,     0,   149,     0,   150,   151,     0,     0,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   152,   153,   197,     0,
     138,   139,   140,   141,   142,   143,   144,   145,   154,   155,
       0,     0,   146,   147,     0,   148,     0,     0,     0,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,   156,   157,     0,     0,     0,     0,     0,     0,     0,
     158,   152,   138,   139,   140,   141,   142,   143,   144,   145,
     577,   578,   579,   580,   146,   147,     0,   148,   159,     0,
       0,   149,     0,   150,   151,     0,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,   156,   157,     0,     0,
       0,     0,     0,   152,   153,   158,   138,   139,   140,   141,
     142,   143,   144,   145,     0,   154,   155,     0,   146,   147,
       0,   148,     0,   159,     0,   149,   198,     0,     0,     0,
       0,   160,   161,   162,   163,   164,   165,     0,   156,   157,
       0,     0,     0,     0,     0,     0,     0,   158,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
     146,   147,     0,   148,     0,   159,     0,   149,     0,   150,
     151,     0,     0,   160,   161,   162,   163,   164,   165,     0,
       0,     0,   156,   157,     0,     0,     0,     0,     0,   152,
     153,   158,     0,   138,   139,   140,   141,   142,   143,   144,
     145,   154,   155,     0,     0,   146,   147,     0,   148,   221,
       0,   611,   149,     0,   150,   151,     0,     0,     0,     0,
       0,     0,     0,     0,   156,   157,     0,     0,     0,     0,
       0,     0,     0,   158,   152,   153,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   154,   155,     0,     0,
       0,   159,   466,     0,     0,     0,     0,     0,     0,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,   156,
     157,     0,     0,     0,     0,     0,     0,     0,   158,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,     0,
       0,   146,   147,     0,   148,     0,   159,   522,   149,     0,
     150,   151,     0,     0,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     152,   153,     0,     0,   138,   139,   140,   141,   142,   143,
     144,   145,   154,   155,     0,     0,   146,   147,     0,   148,
       0,     0,     0,   149,     0,   150,   151,     0,     0,     0,
       0,     0,     0,     0,     0,   156,   157,     0,     0,     0,
       0,     0,     0,     0,   158,   152,   153,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   154,   155,     0,
       0,     0,   159,   573,     0,     0,     0,     0,     0,     0,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
     156,   157,     0,     0,     0,     0,     0,     0,     0,   158,
     138,   139,   140,   141,   142,   143,   144,   145,     0,     0,
       0,     0,   146,   147,     0,   148,     0,   159,   575,   149,
       0,   150,   151,     0,     0,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   152,   153,     0,     0,   138,   139,   140,   141,   142,
     143,   144,   145,   154,   155,     0,     0,   146,   147,     0,
     148,     0,     0,     0,   149,     0,   150,   151,     0,     0,
       0,     0,     0,     0,     0,     0,   156,   157,     0,     0,
       0,     0,     0,     0,     0,   158,   152,   153,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   154,   155,
       0,     0,     0,   159,   590,     0,     0,     0,     0,     0,
       0,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,   156,   157,     0,     0,     0,     0,     0,     0,     0,
     158,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,     0,     0,   146,   147,     0,   148,     0,   159,   613,
     149,     0,   150,   151,     0,     0,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   152,   153,     0,     0,   138,   139,   140,   141,
     142,   143,   144,   145,   154,   155,     0,     0,   146,   147,
       0,   148,     0,     0,     0,   149,     0,   150,   151,     0,
       0,     0,     0,     0,     0,     0,     0,   156,   157,     0,
       0,     0,     0,     0,     0,     0,   158,   152,   153,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   154,
     155,     0,     0,     0,   159,   632,     0,     0,     0,     0,
       0,     0,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,   156,   157,     0,     0,     0,     0,     0,     0,
       0,   158,   138,   139,   140,   141,   142,   143,   144,   145,
       0,     0,     0,     0,   146,   147,     0,   148,     0,   159,
     637,   149,     0,   150,   151,     0,     0,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   152,   153,     0,     0,   138,   139,   140,
     141,   142,   143,   144,   145,   154,   155,     0,     0,   146,
     147,     0,   148,     0,     0,     0,   149,     0,   150,   151,
       0,     0,     0,     0,     0,     0,     0,     0,   156,   157,
       0,     0,     0,     0,     0,     0,     0,   158,   152,   153,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     154,   155,     0,     0,     0,   159,   644,     0,     0,     0,
       0,     0,     0,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,   156,   157,     0,     0,     0,     0,     0,
       0,     0,   158,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,     0,
     159,   648,   149,     0,   150,   151,     0,     0,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,   153,   138,   139,   140,   141,
     142,   143,   144,   145,     0,     0,   154,   155,   146,   147,
       0,   148,     0,     0,     0,   149,     0,   150,   151,     0,
     138,   139,   140,   141,   142,   143,   144,   145,     0,   156,
     157,     0,   146,   147,     0,   148,     0,   152,   158,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   159,     0,     0,     0,
       0,   152,     0,     0,   160,   161,   162,   163,   164,   165,
       0,     0,   156,   157,     0,     0,     0,     0,     0,     0,
       0,   158,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   156,   157,     0,   159,
       0,     0,   452,     0,     0,   158,     0,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   159,     0,     0,   516,     0,     0,     0,
       0,   160,   161,   162,   163,   164,   165,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,   146,
     147,     0,   148,     0,     0,     0,   149,     0,   150,   151,
     138,   139,   140,   141,   142,   143,   144,   145,     0,     0,
       0,     0,   146,   147,     0,   148,     0,     0,   152,   149,
       0,   150,   151,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,     0,
       0,   152,   149,     0,   150,   151,     0,     0,     0,     0,
       0,     0,     0,   156,   157,     0,     0,     0,     0,     0,
       0,     0,   158,     0,   152,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   156,   157,     0,     0,
     159,     0,     0,     0,     0,   158,     0,     0,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,   156,
     157,   448,     0,   221,     0,     0,     0,     0,   158,     0,
       0,   160,   161,   162,   163,   164,   165,     0,    61,     0,
       2,     0,     0,     0,     0,     0,   224,     0,     0,     0,
       0,     0,     0,     0,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,     0,     0,    57,    58,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,   448,
       0,     0,     0,     0,   138,   139,   140,   141,   142,   143,
     144,   145,     0,     0,     0,     0,   146,   147,     2,   148,
       0,     0,     0,   149,     0,     0,   343,   449,   344,     0,
       0,     0,     0,     0,    63,    64,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    57,    58,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,     0,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,     0,     0,     0,
     156,   157,     0,     0,     0,     2,     0,     0,     0,   158,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   365,   449,   344,   221,     0,     0,
       0,     0,    63,    64,    58,     2,     6,     7,     8,     9,
       0,    11,    12,     0,     0,    15,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    58,     0,     6,     7,     8,     9,
       0,    11,    12,     2,     0,    15,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,     0,     0,     0,     0,     0,     0,
       0,     0,    58,     2,     6,     7,     8,     9,     0,    11,
      12,     0,     0,    15,   112,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    58,     0,     6,     7,     8,     9,     0,    11,
      12,     0,     0,    15,   120,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,   138,   139,   140,   141,   142,   143,   144,   145,
       0,     0,     0,     0,   146,   147,     0,   148,     0,     0,
       0,   149,   205,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,     0,
       0,     0,   149,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   156,   157,
       0,     0,     0,     0,     0,   191,     0,   158,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   156,
     157,     0,     0,     0,     2,   221,     0,   228,   158,     0,
     229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   221,     0,   518,     0,
       0,   519,    57,    58,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,   448,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,     0,     2,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,    57,    58,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     0,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,     0,     2,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   514,    57,    58,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     0,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,     0,     0,     0,     0,     0,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    73,    57,    58,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,     2,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    58,     0,
       6,     7,     8,     9,     0,    11,    12,     0,     0,    15,
       0,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32
};

static const yytype_int16 yycheck[] =
{
     105,   158,     0,   105,   108,   129,   107,    70,    71,    64,
     162,   163,   164,   165,    75,    37,    18,    78,    18,   127,
     113,    18,     0,   106,    18,   129,   119,    73,    33,    18,
      18,    20,   130,    28,    29,   110,   108,    35,    36,   110,
      38,    39,   159,   193,    19,   110,   101,    45,    46,    18,
     110,   110,   113,    17,   129,   116,   127,   129,   119,   193,
     121,   166,   361,   106,   129,   108,   159,   111,    46,   129,
     129,    19,   229,    64,   346,   347,   116,   117,   150,   151,
     152,   103,    18,   110,    75,    17,   236,    78,   160,   161,
     162,   163,   164,   165,   366,   367,   118,   126,   159,   128,
     127,   123,   236,   298,   221,    83,   106,   224,   108,   107,
     101,   263,   264,   265,   309,   116,   111,   112,   106,   124,
     121,   219,   113,   228,   319,   116,    18,   129,   119,   324,
     121,   224,   129,   250,   128,   110,   115,   106,   193,   128,
     126,   120,   121,   110,   249,   114,   115,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   204,   107,
     127,   110,   110,   224,   281,   110,   465,   110,   159,   293,
     106,   193,   108,   106,   291,   108,   125,   107,   114,   115,
     110,   236,   127,    18,   127,   270,   271,   272,   273,   293,
     307,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   343,
      23,    24,    25,   110,   106,   128,   107,   369,   128,   110,
     344,   293,   114,   115,   419,   128,    23,    24,    25,   107,
     127,   365,   110,   224,    18,   127,    23,    24,    25,   128,
     344,   106,   541,   108,    26,    27,    23,    24,    25,   114,
     115,     3,   447,     5,   112,     7,   361,     9,   557,   364,
     107,    23,    24,    25,   107,   370,   107,   110,   370,   110,
      30,    31,   344,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,   346,   347,   112,   481,   482,   343,   107,
     589,   107,   110,   106,   110,   108,   413,   369,   107,   107,
     113,   110,   110,   420,   421,   422,   463,   412,   128,   106,
     365,   108,   106,   430,   108,   432,   113,   616,   106,   106,
     108,   108,   107,   129,   107,   110,   113,   110,   127,   106,
     629,   108,   107,   355,   458,   110,   113,   532,   533,   534,
     111,   536,   641,   538,   106,   343,   108,   646,   126,   454,
     114,   113,   454,   351,   458,    45,   457,   122,   107,   464,
     465,   110,   519,   107,    45,   126,   110,   365,   107,   474,
     123,   110,   107,   477,   107,   110,   107,   110,   573,   110,
     575,   498,   499,    23,    24,    25,   458,    32,   583,   107,
     585,   586,   110,   107,   107,   107,   110,   110,   110,   129,
     595,   558,   597,   107,   107,   477,   110,   602,   107,   604,
      51,   110,   107,   518,   107,   110,   107,   110,   535,   110,
     537,   109,   110,   528,   110,   542,   528,   109,   545,   546,
     109,   588,   627,   107,    75,   552,   541,    78,    23,    24,
      25,   107,   547,    18,    23,    24,    25,    23,    24,    25,
     109,   110,   557,    18,   559,   109,   110,   109,   110,   457,
     617,   266,   267,   127,   268,   269,   106,   125,   108,   441,
     442,   128,   113,   113,   125,   116,   106,   582,   119,   636,
     121,   274,   275,   124,   589,   441,   442,   106,   106,    18,
     127,   127,   106,   106,   127,   106,   106,     0,   106,   106,
     605,   106,   106,   106,   106,   125,   611,    19,   107,   126,
     107,   616,   112,   109,    86,   127,   125,    20,   159,    86,
      18,   106,    18,   108,   629,    18,   110,   106,   113,   108,
     106,   109,   108,   107,   113,   106,   641,   113,   107,   126,
     106,   646,    47,   184,   107,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,   107,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,   109,    49,   112,    51,
      52,    53,    54,   224,    56,    57,   127,   109,    60,   112,
      84,    63,    64,    84,    93,   109,   127,   127,    70,   127,
     127,   112,     1,   109,     3,     4,     5,     6,     7,     8,
       9,    10,   112,   435,   276,   278,    15,    16,   279,    18,
     280,    20,    21,    22,   127,    24,    25,   277,   184,   103,
     127,    78,   355,    31,    97,   351,   224,   106,   412,   499,
     442,   282,   283,   115,   285,    44,    45,    46,   417,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,   549,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,   444,    85,    86,    87,    88,
      89,    90,    91,    92,    46,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,    -1,   304,
      -1,    20,    -1,    -1,    -1,   114,   115,   116,   117,   118,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,   128,
     129,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
      20,    21,    22,    62,    24,    25,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      -1,    -1,    -1,    -1,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,   116,   117,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,   128,   129,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,    20,
      21,    22,    -1,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    88,    89,    90,
      91,    92,     1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,    -1,    -1,
      -1,    20,    -1,   114,   115,   116,   117,   118,   119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   127,   128,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    -1,    18,    -1,    -1,    -1,    22,
      -1,    24,    25,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      18,    44,    45,    -1,    22,    -1,    24,    25,   127,    -1,
      -1,    -1,    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    56,    57,
      -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,   106,    -1,    -1,    -1,    -1,    -1,    -1,
      88,   114,   115,   116,   117,   118,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   128,   129,    -1,   106,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,
     118,   119,     3,     4,     5,     6,     7,     8,     9,    10,
     128,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,    20,
      -1,    22,    -1,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    45,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,   106,    -1,    22,    -1,    24,
      25,    -1,    -1,   114,   115,   116,   117,   118,   119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    44,
      45,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    56,    57,    -1,    -1,    15,    16,    -1,    18,    -1,
      -1,    -1,    22,    -1,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    44,    45,    -1,    20,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,    -1,
      -1,   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
     115,   116,   117,   118,   119,    -1,    -1,    -1,    -1,    79,
      80,    -1,   127,    56,    57,    -1,    59,    -1,    88,    62,
      -1,    -1,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    74,    75,    76,    77,    78,   106,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,   116,   117,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,     1,   127,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,    20,    -1,    22,    -1,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      45,    -1,    -1,    -1,    49,    -1,    51,    52,    53,    54,
      -1,    56,    57,    -1,    -1,    60,    -1,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    88,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,
      -1,   106,    -1,    22,    -1,    24,    25,    -1,    -1,   114,
     115,   116,   117,   118,   119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    45,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    56,    57,    -1,
      -1,    15,    16,    -1,    18,    -1,    -1,    -1,    22,    -1,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    57,    -1,    -1,    -1,   106,   107,    -1,
      -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,   118,
     119,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    88,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      18,    -1,   106,    -1,    22,    -1,    24,    25,    -1,    -1,
     114,   115,   116,   117,   118,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    45,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    56,    57,
      -1,    -1,    15,    16,    -1,    18,    -1,    -1,    -1,    22,
      -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    44,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    -1,    18,   106,    -1,
      -1,    22,    -1,    24,    25,    -1,   114,   115,   116,   117,
     118,   119,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    44,    45,    88,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    56,    57,    -1,    15,    16,
      -1,    18,    -1,   106,    -1,    22,   109,    -1,    -1,    -1,
      -1,   114,   115,   116,   117,   118,   119,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,   106,    -1,    22,    -1,    24,
      25,    -1,    -1,   114,   115,   116,   117,   118,   119,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    44,
      45,    88,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    56,    57,    -1,    -1,    15,    16,    -1,    18,   106,
      -1,   108,    22,    -1,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    44,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,    -1,
      -1,   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,   114,
     115,   116,   117,   118,   119,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    -1,    18,    -1,   106,   107,    22,    -1,
      24,    25,    -1,    -1,   114,   115,   116,   117,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    45,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    56,    57,    -1,    -1,    15,    16,    -1,    18,
      -1,    -1,    -1,    22,    -1,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,
      -1,    -1,   106,   107,    -1,    -1,    -1,    -1,    -1,    -1,
     114,   115,   116,   117,   118,   119,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    -1,    18,    -1,   106,   107,    22,
      -1,    24,    25,    -1,    -1,   114,   115,   116,   117,   118,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    44,    45,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    56,    57,    -1,    -1,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    -1,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    44,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,    57,
      -1,    -1,    -1,   106,   107,    -1,    -1,    -1,    -1,    -1,
      -1,   114,   115,   116,   117,   118,   119,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      88,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    18,    -1,   106,   107,
      22,    -1,    24,    25,    -1,    -1,   114,   115,   116,   117,
     118,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    44,    45,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    56,    57,    -1,    -1,    15,    16,
      -1,    18,    -1,    -1,    -1,    22,    -1,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    44,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      57,    -1,    -1,    -1,   106,   107,    -1,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,   118,   119,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,   106,
     107,    22,    -1,    24,    25,    -1,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    45,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    56,    57,    -1,    -1,    15,
      16,    -1,    18,    -1,    -1,    -1,    22,    -1,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    57,    -1,    -1,    -1,   106,   107,    -1,    -1,    -1,
      -1,    -1,    -1,   114,   115,   116,   117,   118,   119,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
     106,   107,    22,    -1,    24,    25,    -1,    -1,   114,   115,
     116,   117,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    56,    57,    15,    16,
      -1,    18,    -1,    -1,    -1,    22,    -1,    24,    25,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    79,
      80,    -1,    15,    16,    -1,    18,    -1,    44,    88,    22,
      -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,
      -1,    44,    -1,    -1,   114,   115,   116,   117,   118,   119,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,   106,
      -1,    -1,   109,    -1,    -1,    88,    -1,   114,   115,   116,
     117,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   106,    -1,    -1,   109,    -1,    -1,    -1,
      -1,   114,   115,   116,   117,   118,   119,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    18,    -1,    -1,    -1,    22,    -1,    24,    25,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    -1,    18,    -1,    -1,    44,    22,
      -1,    24,    25,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
      -1,    44,    22,    -1,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
     106,    -1,    -1,    -1,    -1,    88,    -1,    -1,   114,   115,
     116,   117,   118,   119,    -1,    -1,    -1,    -1,    -1,    79,
      80,     1,    -1,   106,    -1,    -1,    -1,    -1,    88,    -1,
      -1,   114,   115,   116,   117,   118,   119,    -1,    18,    -1,
      20,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,   115,   116,   117,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,     1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    20,    18,
      -1,    -1,    -1,    22,    -1,    -1,   106,   107,   108,    -1,
      -1,    -1,    -1,    -1,   114,   115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    20,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   106,   107,   108,   106,    -1,    -1,
      -1,    -1,   114,   115,    49,    20,    51,    52,    53,    54,
      -1,    56,    57,    -1,    -1,    60,    -1,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    49,    -1,    51,    52,    53,    54,
      -1,    56,    57,    20,    -1,    60,    -1,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    20,    51,    52,    53,    54,    -1,    56,
      57,    -1,    -1,    60,   129,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    49,    -1,    51,    52,    53,    54,    -1,    56,
      57,    -1,    -1,    60,   129,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,    -1,
      -1,    22,   129,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    20,   106,    -1,   108,    88,    -1,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   106,    -1,   108,    -1,
      -1,   111,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,     1,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    20,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   107,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    20,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   107,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    20,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      51,    52,    53,    54,    -1,    56,    57,    -1,    -1,    60,
      -1,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    20,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,   127,   157,   158,   161,   162,   165,   166,
     168,   171,   172,   173,   180,   183,   234,   235,   236,   127,
      17,   128,   106,   111,    18,   128,   179,    48,    49,   162,
     162,    18,   106,   114,   115,   127,   163,   164,   185,   187,
     188,   189,   162,   111,   162,   128,    18,    20,   128,   170,
     162,     0,   235,   128,   166,   167,    18,   159,   160,     3,
       5,     7,     9,   186,   179,   181,   182,   128,    17,   185,
     183,   184,   188,   110,   127,   126,   237,   106,   108,   187,
     187,   186,   129,   166,   168,   169,   174,   175,   176,   183,
     129,   174,   157,   162,   110,   129,   107,   110,   112,   126,
     110,   129,   181,   107,   183,   188,   164,   185,     3,     4,
       5,     6,     7,     8,     9,    10,    15,    16,    18,    22,
      24,    25,    44,    45,    56,    57,    79,    80,    88,   106,
     114,   115,   116,   117,   118,   119,   128,   132,   133,   134,
     135,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   152,   153,   196,   128,   202,
     204,     1,   107,   162,   190,   191,   192,     1,   109,   137,
     149,   155,   112,   176,   111,   129,   175,   177,   178,   185,
     176,   129,   129,   166,   127,   159,   155,   129,   182,   110,
     129,   106,   137,   137,   106,   137,    45,    45,   108,   111,
     134,     1,    56,    57,   153,   154,   176,   193,   137,   137,
     138,   138,   138,   138,   196,   197,    23,    24,    25,   106,
     108,   113,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,   126,   115,   120,   121,   116,   117,    26,    27,
      28,    29,   111,   112,    30,    31,   114,   122,   123,    32,
      33,   124,    56,    57,   151,   158,   166,   129,     1,    18,
      21,    46,    60,    81,    82,    83,    85,    86,    87,    89,
      90,    91,    92,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   127,   154,   156,   157,   198,
     199,   200,   201,   204,   205,   206,   207,   210,   211,   212,
     213,   215,   220,   222,   227,   228,   229,   230,   231,   232,
     233,   107,   110,   106,   108,   185,   188,   189,   194,   195,
     107,   110,   109,   109,   186,   110,   127,   129,   193,   153,
     134,   106,   107,   107,   110,   106,   188,   189,   194,   107,
     110,   129,    18,     1,   107,   136,   153,     1,   154,    18,
     153,   153,   153,   153,   153,   153,   153,   153,   153,   153,
     153,   138,   138,   138,   139,   139,   140,   140,   141,   141,
     141,   141,   142,   142,   143,   144,   145,   146,   147,   154,
     166,   166,   106,   108,   166,   127,   154,   128,   155,   125,
     106,   106,   106,   199,    18,   227,   127,   127,   127,   154,
     106,   199,   106,   127,   106,   106,   127,   199,   129,   199,
     203,   106,   106,   106,   106,   106,   106,   125,     1,   107,
     190,   194,   109,   155,   126,   195,   195,   106,   108,   192,
     112,   178,   107,   109,   110,   106,   107,   136,   153,   138,
     129,   196,   107,   107,   110,   109,   109,   125,   197,   154,
     127,   205,   125,   199,   154,   154,   154,    86,   127,   127,
     154,    86,   154,    19,   131,   131,   156,   206,   209,   209,
      18,   214,   218,   219,   219,    18,   216,    18,   221,   199,
     107,   107,   109,   196,   107,   190,   109,   155,   108,   111,
     134,   153,   107,   136,   107,   153,   149,   107,   110,   109,
     129,   199,   107,   107,   107,   106,   107,   106,   107,    19,
     107,   110,   110,   127,   154,   208,   208,   126,   107,   110,
     107,   107,    47,   107,   109,   153,   134,   106,   109,   110,
     112,   107,   199,   199,   199,   154,   199,   154,   199,   127,
     136,   154,   127,   107,   154,   107,   154,    11,    12,    13,
      14,   153,   217,   223,   218,   224,   225,   154,   109,   106,
     107,   136,   134,   153,   112,    84,   107,    84,   107,   107,
     107,   199,   107,   199,   107,    93,   153,   199,   199,   199,
     107,   108,   134,   107,   136,   107,   106,   109,   199,   127,
     199,   127,   127,   127,   199,   199,   153,   226,   153,   106,
     112,   107,   107,   136,   134,   199,   109,   107,   136,   112,
     107,   106,   134,   107,   107,   136,   106,   107,   107,   136,
     107
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   130,   131,   131,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   134,   134,   134,   134,
     134,   134,   134,   134,   135,   135,   135,   135,   136,   136,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   138,   138,   139,   139,   139,   139,   140,   140,   140,
     141,   141,   141,   142,   142,   142,   142,   142,   143,   143,
     143,   144,   144,   145,   145,   146,   146,   147,   147,   148,
     148,   149,   149,   150,   150,   150,   151,   151,   151,   151,
     152,   152,   152,   152,   153,   153,   153,   153,   153,   153,
     153,   153,   153,   153,   153,   153,   154,   154,   155,   156,
     157,   157,   158,   159,   160,   160,   161,   162,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   162,   163,   163,
     164,   164,   165,   165,   165,   165,   166,   166,   166,   166,
     167,   167,   168,   168,   168,   168,   168,   168,   168,   168,
     168,   168,   168,   168,   169,   170,   170,   171,   172,   172,
     172,   172,   172,   173,   174,   174,   175,   176,   176,   176,
     176,   177,   177,   178,   179,   180,   180,   180,   180,   180,
     181,   181,   182,   182,   183,   183,   183,   183,   183,   183,
     183,   183,   183,   183,   183,   184,   184,   185,   185,   185,
     186,   186,   186,   186,   187,   187,   187,   187,   187,   187,
     187,   187,   188,   188,   188,   188,   189,   190,   191,   191,
     191,   192,   192,   192,   192,   193,   193,   194,   194,   194,
     194,   194,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   196,   196,   196,   197,   197,   198,   199,   199,   200,
     200,   200,   200,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   201,   201,   201,   202,   203,   204,   204,   205,
     205,   206,   206,   207,   207,   207,   207,   207,   208,   208,
     209,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     217,   217,   217,   218,   218,   219,   219,   220,   221,   222,
     222,   222,   222,   222,   222,   222,   222,   223,   222,   224,
     222,   225,   222,   226,   222,   227,   228,   228,   228,   228,
     228,   229,   230,   231,   232,   232,   233,   234,   234,   234,
     235,   235,   235,   235,   235,   237,   236
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       5,     4,     8,     7,    10,     9,    11,    10,    12,    11,
      14,    13,     7,     6,    10,     9,     1,     4,     4,     1,
       3,     3,     2,     2,     1,     3,     4,     4,     1,     3,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     1,     4,     1,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     5,     1,     2,     2,     1,     2,     2,     2,
       1,     2,     5,     5,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     1,     1,
       2,     3,     4,     1,     1,     3,     4,     1,     2,     1,
       2,     1,     2,     1,     4,     2,     1,     2,     1,     3,
       1,     3,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     1,     2,     1,     4,
       4,     3,     3,     1,     1,     2,     3,     2,     1,     1,
       2,     1,     3,     1,     1,     4,     5,     5,     6,     2,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     3,     4,     3,     4,     4,
       3,     4,     1,     2,     2,     3,     1,     1,     1,     3,
       2,     2,     4,     2,     1,     1,     2,     1,     1,     2,
       1,     2,     3,     2,     3,     3,     4,     2,     3,     3,
       4,     1,     3,     4,     1,     3,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     4,     3,     1,     1,     2,     3,     1,
       2,     1,     2,     5,     7,     5,     7,     5,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     4,     1,     3,     1,     1,     5,
       5,     7,     7,     6,     7,     6,     7,     0,     6,     0,
       6,     0,     6,     0,     8,     1,     3,     2,     2,     2,
       3,     2,     3,     4,     5,     7,     7,     1,     2,     2,
       1,     5,     5,     1,     1,     0,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* string_constant: TOKEN_STRING_LITERAL  */
#line 279 "src/parse.yy"
                           { (yyval.stringVal) = new std::string(*yylval.stringVal); }
#line 2830 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 3: /* string_constant: string_constant TOKEN_STRING_LITERAL  */
#line 281 "src/parse.yy"
    {
        std::string s = *((std::string *)(yyvsp[-1].stringVal));
        s += *yylval.stringVal;
        (yyval.stringVal) = new std::string(s);
    }
#line 2840 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 4: /* primary_expression: TOKEN_IDENTIFIER  */
#line 289 "src/parse.yy"
                       {
        const char *name = yylval.stringVal->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        (yyval.expr) = NULL;
        if (s)
            (yyval.expr) = new SymbolExpr(s, (yylsp[0]));
        else {
            std::vector<Symbol *> funs;
            m->symbolTable->LookupFunction(name, &funs);
            if (funs.size() > 0)
                (yyval.expr) = new FunctionSymbolExpr(name, funs, (yylsp[0]));
        }
        if ((yyval.expr) == NULL) {
            std::vector<std::string> alternates =
                m->symbolTable->ClosestVariableOrFunctionMatch(name);
            std::string alts = lGetAlternates(alternates);
            Error((yylsp[0]), "Undeclared symbol \"%s\".%s", name, alts.c_str());
        }
    }
#line 2864 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 5: /* primary_expression: TOKEN_INT8_CONSTANT  */
#line 308 "src/parse.yy"
                          {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0]));
    }
#line 2873 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 6: /* primary_expression: TOKEN_UINT8_CONSTANT  */
#line 312 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0]));
    }
#line 2882 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 7: /* primary_expression: TOKEN_INT16_CONSTANT  */
#line 316 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0]));
    }
#line 2891 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 8: /* primary_expression: TOKEN_UINT16_CONSTANT  */
#line 320 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0]));
    }
#line 2900 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 9: /* primary_expression: TOKEN_INT32_CONSTANT  */
#line 324 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 2909 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 10: /* primary_expression: TOKEN_UINT32_CONSTANT  */
#line 328 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 2918 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 11: /* primary_expression: TOKEN_INT64_CONSTANT  */
#line 332 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 2927 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 12: /* primary_expression: TOKEN_UINT64_CONSTANT  */
#line 336 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 2936 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 13: /* primary_expression: TOKEN_FLOAT_CONSTANT  */
#line 340 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformFloat->GetAsConstType(),
                           yylval.floatVal, (yylsp[0]));
    }
#line 2945 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 14: /* primary_expression: TOKEN_DOUBLE_CONSTANT  */
#line 344 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformDouble->GetAsConstType(),
                           yylval.doubleVal, (yylsp[0]));
    }
#line 2954 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 15: /* primary_expression: TOKEN_TRUE  */
#line 348 "src/parse.yy"
                 {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0]));
    }
#line 2962 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 16: /* primary_expression: TOKEN_FALSE  */
#line 351 "src/parse.yy"
                  {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0]));
    }
#line 2970 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 17: /* primary_expression: TOKEN_NULL  */
#line 354 "src/parse.yy"
                 {
        (yyval.expr) = new NullPointerExpr((yylsp[0]));
    }
#line 2978 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 18: /* primary_expression: '(' expression ')'  */
#line 359 "src/parse.yy"
                         { (yyval.expr) = (yyvsp[-1].expr); }
#line 2984 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 19: /* primary_expression: '(' error ')'  */
#line 360 "src/parse.yy"
                    { (yyval.expr) = NULL; }
#line 2990 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 20: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' argument_expression_list ')'  */
#line 365 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]), (yylsp[0])), true, launchCount);
      }
#line 3000 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 21: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' ')'  */
#line 371 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-1]),(yylsp[0]))), Union((yylsp[-2]), (yylsp[0])), true, launchCount);
       }
#line 3010 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 22: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 378 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3020 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 23: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 384 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3030 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 24: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 391 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-7].expr), (yyvsp[-5].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3040 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 25: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 397 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-6].expr), (yyvsp[-4].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3050 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 26: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 403 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3060 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 27: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 409 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3070 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 28: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 416 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-9].expr), (yyvsp[-7].expr), (yyvsp[-5].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3079 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 29: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 421 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3088 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 30: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 426 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), (yyvsp[-11].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3097 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 31: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 431 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), (yyvsp[-10].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3106 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 32: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 438 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3116 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 33: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' ')' '>'  */
#line 444 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3126 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 34: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 450 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3136 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 35: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' ')' '>'  */
#line 456 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3146 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 37: /* postfix_expression: postfix_expression '[' expression ']'  */
#line 466 "src/parse.yy"
      { (yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].expr), Union((yylsp[-3]),(yylsp[0]))); }
#line 3152 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 38: /* postfix_expression: postfix_expression '[' error ']'  */
#line 468 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3158 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 40: /* postfix_expression: postfix_expression '.' TOKEN_IDENTIFIER  */
#line 471 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false); }
#line 3164 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 41: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_IDENTIFIER  */
#line 473 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true); }
#line 3170 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 42: /* postfix_expression: postfix_expression TOKEN_INC_OP  */
#line 475 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostInc, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3176 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 43: /* postfix_expression: postfix_expression TOKEN_DEC_OP  */
#line 477 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostDec, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3182 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 45: /* funcall_expression: postfix_expression '(' ')'  */
#line 483 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0]))); }
#line 3188 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 46: /* funcall_expression: postfix_expression '(' argument_expression_list ')'  */
#line 485 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0]))); }
#line 3194 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 47: /* funcall_expression: postfix_expression '(' error ')'  */
#line 487 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3200 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 48: /* argument_expression_list: assignment_expression  */
#line 491 "src/parse.yy"
                                 { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 3206 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 49: /* argument_expression_list: argument_expression_list ',' assignment_expression  */
#line 493 "src/parse.yy"
      {
          ExprList *argList = llvm::dyn_cast<ExprList>((yyvsp[-2].exprList));
          if (argList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              argList = new ExprList((yylsp[0]));
          }
          argList->exprs.push_back((yyvsp[0].expr));
          argList->pos = Union(argList->pos, (yylsp[0]));
          (yyval.exprList) = argList;
      }
#line 3221 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 51: /* unary_expression: TOKEN_INC_OP unary_expression  */
#line 508 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreInc, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3227 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 52: /* unary_expression: TOKEN_DEC_OP unary_expression  */
#line 510 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreDec, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3233 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 53: /* unary_expression: '&' unary_expression  */
#line 512 "src/parse.yy"
      { (yyval.expr) = new AddressOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3239 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 54: /* unary_expression: '*' unary_expression  */
#line 514 "src/parse.yy"
      { (yyval.expr) = new PtrDerefExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3245 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 55: /* unary_expression: '+' cast_expression  */
#line 516 "src/parse.yy"
      { (yyval.expr) = (yyvsp[0].expr); }
#line 3251 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 56: /* unary_expression: '-' cast_expression  */
#line 518 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::Negate, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3257 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 57: /* unary_expression: '~' cast_expression  */
#line 520 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::BitNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3263 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 58: /* unary_expression: '!' cast_expression  */
#line 522 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::LogicalNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3269 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 59: /* unary_expression: TOKEN_SIZEOF unary_expression  */
#line 524 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3275 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 60: /* unary_expression: TOKEN_SIZEOF '(' type_name ')'  */
#line 526 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[-1].type), Union((yylsp[-3]), (yylsp[0]))); }
#line 3281 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 62: /* cast_expression: '(' type_name ')' cast_expression  */
#line 532 "src/parse.yy"
      {
          (yyval.expr) = new TypeCastExpr((yyvsp[-2].type), (yyvsp[0].expr), Union((yylsp[-3]),(yylsp[0])));
      }
#line 3289 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 64: /* multiplicative_expression: multiplicative_expression '*' cast_expression  */
#line 540 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mul, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3295 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 65: /* multiplicative_expression: multiplicative_expression '/' cast_expression  */
#line 542 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Div, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3301 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 66: /* multiplicative_expression: multiplicative_expression '%' cast_expression  */
#line 544 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mod, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3307 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 68: /* additive_expression: additive_expression '+' multiplicative_expression  */
#line 550 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Add, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3313 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 69: /* additive_expression: additive_expression '-' multiplicative_expression  */
#line 552 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Sub, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3319 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 71: /* shift_expression: shift_expression TOKEN_LEFT_OP additive_expression  */
#line 558 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shl, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3325 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 72: /* shift_expression: shift_expression TOKEN_RIGHT_OP additive_expression  */
#line 560 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3331 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 74: /* relational_expression: relational_expression '<' shift_expression  */
#line 566 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Lt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3337 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 75: /* relational_expression: relational_expression '>' shift_expression  */
#line 568 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Gt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3343 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 76: /* relational_expression: relational_expression TOKEN_LE_OP shift_expression  */
#line 570 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Le, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3349 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 77: /* relational_expression: relational_expression TOKEN_GE_OP shift_expression  */
#line 572 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Ge, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3355 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 79: /* equality_expression: equality_expression TOKEN_EQ_OP relational_expression  */
#line 578 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Equal, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3361 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 80: /* equality_expression: equality_expression TOKEN_NE_OP relational_expression  */
#line 580 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::NotEqual, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3367 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 82: /* and_expression: and_expression '&' equality_expression  */
#line 586 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3373 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 84: /* exclusive_or_expression: exclusive_or_expression '^' and_expression  */
#line 592 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitXor, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3379 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 86: /* inclusive_or_expression: inclusive_or_expression '|' exclusive_or_expression  */
#line 598 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3385 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 88: /* logical_and_expression: logical_and_expression TOKEN_AND_OP inclusive_or_expression  */
#line 604 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3391 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 90: /* logical_or_expression: logical_or_expression TOKEN_OR_OP logical_and_expression  */
#line 610 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3397 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 92: /* conditional_expression: logical_or_expression '?' expression ':' conditional_expression  */
#line 616 "src/parse.yy"
      { (yyval.expr) = new SelectExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-4]),(yylsp[0]))); }
#line 3403 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 93: /* rate_qualified_new: TOKEN_NEW  */
#line 620 "src/parse.yy"
                { (yyval.intVal) = 0; }
#line 3409 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 94: /* rate_qualified_new: TOKEN_UNIFORM TOKEN_NEW  */
#line 621 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_UNIFORM; }
#line 3415 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 95: /* rate_qualified_new: TOKEN_VARYING TOKEN_NEW  */
#line 622 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_VARYING; }
#line 3421 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 96: /* rate_qualified_type_specifier: type_specifier  */
#line 626 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].type); }
#line 3427 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 97: /* rate_qualified_type_specifier: TOKEN_UNIFORM type_specifier  */
#line 628 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
    }
#line 3442 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 98: /* rate_qualified_type_specifier: TOKEN_VARYING type_specifier  */
#line 639 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
    }
#line 3457 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 99: /* rate_qualified_type_specifier: soa_width_specifier type_specifier  */
#line 650 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else {
            int soaWidth = (int)(yyvsp[-1].intVal);
            const StructType *st = CastType<StructType>((yyvsp[0].type));
            if (st == NULL) {
                Error((yylsp[-1]), "\"soa\" qualifier is illegal with non-struct type \"%s\".",
                      (yyvsp[0].type)->GetString().c_str());
                (yyval.type) = NULL;
            }
            else if (soaWidth <= 0 || (soaWidth & (soaWidth - 1)) != 0) {
                Error((yylsp[-1]), "soa<%d> width illegal. Value must be positive power "
                      "of two.", soaWidth);
                (yyval.type) = NULL;
            }
            else
                (yyval.type) = st->GetAsSOAType(soaWidth);
        }
    }
#line 3482 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 101: /* new_expression: rate_qualified_new rate_qualified_type_specifier  */
#line 675 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-1].intVal), (yyvsp[0].type), NULL, NULL, (yylsp[-1]), Union((yylsp[-1]), (yylsp[0])));
    }
#line 3490 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 102: /* new_expression: rate_qualified_new rate_qualified_type_specifier '(' initializer_list ')'  */
#line 679 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), (yyvsp[-1].exprList), NULL, (yylsp[-4]), Union((yylsp[-4]), (yylsp[-3])));
    }
#line 3498 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 103: /* new_expression: rate_qualified_new rate_qualified_type_specifier '[' expression ']'  */
#line 683 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), NULL, (yyvsp[-1].expr), (yylsp[-4]), Union((yylsp[-4]), (yylsp[-1])));
    }
#line 3506 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 105: /* assignment_expression: unary_expression '=' assignment_expression  */
#line 691 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::Assign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3512 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 106: /* assignment_expression: unary_expression TOKEN_MUL_ASSIGN assignment_expression  */
#line 693 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::MulAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3518 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 107: /* assignment_expression: unary_expression TOKEN_DIV_ASSIGN assignment_expression  */
#line 695 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::DivAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3524 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 108: /* assignment_expression: unary_expression TOKEN_MOD_ASSIGN assignment_expression  */
#line 697 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ModAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3530 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 109: /* assignment_expression: unary_expression TOKEN_ADD_ASSIGN assignment_expression  */
#line 699 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AddAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3536 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 110: /* assignment_expression: unary_expression TOKEN_SUB_ASSIGN assignment_expression  */
#line 701 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::SubAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3542 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 111: /* assignment_expression: unary_expression TOKEN_LEFT_ASSIGN assignment_expression  */
#line 703 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShlAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3548 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 112: /* assignment_expression: unary_expression TOKEN_RIGHT_ASSIGN assignment_expression  */
#line 705 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3554 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 113: /* assignment_expression: unary_expression TOKEN_AND_ASSIGN assignment_expression  */
#line 707 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AndAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3560 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 114: /* assignment_expression: unary_expression TOKEN_XOR_ASSIGN assignment_expression  */
#line 709 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::XorAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3566 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 115: /* assignment_expression: unary_expression TOKEN_OR_ASSIGN assignment_expression  */
#line 711 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::OrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3572 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 117: /* expression: expression ',' assignment_expression  */
#line 717 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Comma, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3578 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 119: /* declaration_statement: declaration  */
#line 726 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) == NULL) {
            AssertPos((yylsp[0]), m->errorCount > 0);
            (yyval.stmt) = NULL;
        }
        else if ((yyvsp[0].declaration)->declSpecs->storageClass == SC_TYPEDEF) {
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i) {
                if ((yyvsp[0].declaration)->declarators[i] == NULL)
                    AssertPos((yylsp[0]), m->errorCount > 0);
                else
                    m->AddTypeDef((yyvsp[0].declaration)->declarators[i]->name,
                                  (yyvsp[0].declaration)->declarators[i]->type,
                                  (yyvsp[0].declaration)->declarators[i]->pos);
            }
            (yyval.stmt) = NULL;
        }
        else {
            (yyvsp[0].declaration)->DeclareFunctions();
            std::vector<VariableDeclaration> vars = (yyvsp[0].declaration)->GetVariableDeclarations();
            (yyval.stmt) = new DeclStmt(vars, (yylsp[0]));
        }
    }
#line 3605 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 120: /* declaration: declaration_specifiers ';'  */
#line 752 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs));
      }
#line 3613 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 121: /* declaration: declaration_specifiers init_declarator_list ';'  */
#line 756 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-2].declSpecs), (yyvsp[-1].declarators));
      }
#line 3621 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 122: /* soa_width_specifier: TOKEN_SOA '<' int_constant '>'  */
#line 763 "src/parse.yy"
      { (yyval.intVal) = (yyvsp[-1].intVal); }
#line 3627 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 123: /* declspec_item: TOKEN_IDENTIFIER  */
#line 768 "src/parse.yy"
    {
        std::pair<std::string, SourcePos> *p = new std::pair<std::string, SourcePos>;
        p->first = *(yylval.stringVal);
        p->second = (yylsp[0]);
        (yyval.declspecPair) = p;
    }
#line 3638 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 124: /* declspec_list: declspec_item  */
#line 778 "src/parse.yy"
    {
        (yyval.declspecList) = new std::vector<std::pair<std::string, SourcePos> >;
        (yyval.declspecList)->push_back(*(yyvsp[0].declspecPair));
    }
#line 3647 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 125: /* declspec_list: declspec_list ',' declspec_item  */
#line 783 "src/parse.yy"
    {
        if ((yyvsp[-2].declspecList) != NULL)
            (yyvsp[-2].declspecList)->push_back(*(yyvsp[0].declspecPair));
        (yyval.declspecList) = (yyvsp[-2].declspecList);
    }
#line 3657 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 126: /* declspec_specifier: TOKEN_DECLSPEC '(' declspec_list ')'  */
#line 792 "src/parse.yy"
    {
        (yyval.declspecList) = (yyvsp[-1].declspecList);
    }
#line 3665 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 127: /* declaration_specifiers: storage_class_specifier  */
#line 799 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, (yyvsp[0].storageClass));
      }
#line 3673 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 128: /* declaration_specifiers: storage_class_specifier declaration_specifiers  */
#line 803 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->storageClass != SC_NONE)
                  Error((yylsp[-1]), "Multiple storage class specifiers in a declaration are illegal. "
                        "(Have provided both \"%s\" and \"%s\".)",
                        lGetStorageClassString(ds->storageClass),
                        lGetStorageClassString((yyvsp[-1].storageClass)));
              else
                  ds->storageClass = (yyvsp[-1].storageClass);
          }
          (yyval.declSpecs) = ds;
      }
#line 3691 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 129: /* declaration_specifiers: declspec_specifier  */
#line 817 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs;
          if ((yyvsp[0].declspecList) != NULL)
              (yyval.declSpecs)->declSpecList = *(yyvsp[0].declspecList);
      }
#line 3701 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 130: /* declaration_specifiers: declspec_specifier declaration_specifiers  */
#line 823 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          std::vector<std::pair<std::string, SourcePos> > *declSpecList = (yyvsp[-1].declspecList);
          if (ds != NULL && declSpecList != NULL) {
              for (int i = 0; i < (int)declSpecList->size(); ++i)
                  ds->declSpecList.push_back((*declSpecList)[i]);
          }
          (yyval.declSpecs) = ds;
      }
#line 3715 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 131: /* declaration_specifiers: soa_width_specifier  */
#line 833 "src/parse.yy"
      {
          DeclSpecs *ds = new DeclSpecs;
          ds->soaWidth = (int32_t)(yyvsp[0].intVal);
          (yyval.declSpecs) = ds;
      }
#line 3725 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 132: /* declaration_specifiers: soa_width_specifier declaration_specifiers  */
#line 839 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->soaWidth != 0)
                  Error((yylsp[-1]), "soa<> qualifier supplied multiple times in declaration.");
              else
                  ds->soaWidth = (int32_t)(yyvsp[-1].intVal);
          }
          (yyval.declSpecs) = ds;
      }
#line 3740 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 133: /* declaration_specifiers: type_specifier  */
#line 850 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs((yyvsp[0].type));
      }
#line 3748 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 134: /* declaration_specifiers: type_specifier '<' int_constant '>'  */
#line 854 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          ds->vectorSize = (int32_t)(yyvsp[-1].intVal);
          (yyval.declSpecs) = ds;
    }
#line 3758 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 135: /* declaration_specifiers: type_specifier declaration_specifiers  */
#line 860 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->baseType != NULL) {
                  if( ds->baseType->IsUnsignedType()) {
                      Error((yylsp[-1]), "Redefining uint8/uint16/uint32/uint64 type "
                      "which is part of ISPC language since version 1.13. "
                      "Remove this typedef or use ISPC_UINT_IS_DEFINED to "
                      "detect that these types are defined.");
                  }
                  else
                      Error((yylsp[-1]), "Multiple types provided for declaration.");
              }
              ds->baseType = (yyvsp[-1].type);
          }
          (yyval.declSpecs) = ds;
      }
#line 3780 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 136: /* declaration_specifiers: type_qualifier  */
#line 878 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, SC_NONE, (yyvsp[0].typeQualifier));
      }
#line 3788 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 137: /* declaration_specifiers: type_qualifier declaration_specifiers  */
#line 882 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL)
              ds->typeQualifiers |= (yyvsp[-1].typeQualifier);
          (yyval.declSpecs) = ds;
      }
#line 3799 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 138: /* init_declarator_list: init_declarator  */
#line 892 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 3810 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 139: /* init_declarator_list: init_declarator_list ',' init_declarator  */
#line 899 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = (std::vector<Declarator *> *)(yyvsp[-2].declarators);
          if (dl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              dl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 3825 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 141: /* init_declarator: declarator '=' initializer  */
#line 914 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL)
              (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
          (yyval.declarator) = (yyvsp[-2].declarator);
      }
#line 3835 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 142: /* storage_class_specifier: TOKEN_TYPEDEF  */
#line 922 "src/parse.yy"
                    { (yyval.storageClass) = SC_TYPEDEF; }
#line 3841 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 143: /* storage_class_specifier: TOKEN_EXTERN  */
#line 923 "src/parse.yy"
                   { (yyval.storageClass) = SC_EXTERN; }
#line 3847 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 144: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_C_LITERAL  */
#line 924 "src/parse.yy"
                                           { (yyval.storageClass) = SC_EXTERN_C; }
#line 3853 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 145: /* storage_class_specifier: TOKEN_STATIC  */
#line 925 "src/parse.yy"
                   { (yyval.storageClass) = SC_STATIC; }
#line 3859 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 146: /* type_specifier: atomic_var_type_specifier  */
#line 929 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].atomicType); }
#line 3865 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 147: /* type_specifier: TOKEN_TYPE_NAME  */
#line 931 "src/parse.yy"
    {
        const Type *t = m->symbolTable->LookupType(yytext);
        (yyval.type) = t;
    }
#line 3874 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 148: /* type_specifier: struct_or_union_specifier  */
#line 935 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 3880 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 149: /* type_specifier: enum_specifier  */
#line 936 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].enumType); }
#line 3886 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 150: /* type_specifier_list: type_specifier  */
#line 941 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.typeList) = NULL;
        else {
            std::vector<std::pair<const Type *, SourcePos> > *vec =
                new std::vector<std::pair<const Type *, SourcePos> >;
            vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
            (yyval.typeList) = vec;
        }
    }
#line 3901 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 151: /* type_specifier_list: type_specifier_list ',' type_specifier  */
#line 952 "src/parse.yy"
    {
        (yyval.typeList) = (yyvsp[-2].typeList);
        if ((yyvsp[-2].typeList) == NULL)
            Assert(m->errorCount > 0);
        else
            (yyval.typeList)->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
    }
#line 3913 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 152: /* atomic_var_type_specifier: TOKEN_VOID  */
#line 962 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::Void; }
#line 3919 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 153: /* atomic_var_type_specifier: TOKEN_BOOL  */
#line 963 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformBool->GetAsUnboundVariabilityType(); }
#line 3925 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 154: /* atomic_var_type_specifier: TOKEN_INT8  */
#line 964 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformInt8->GetAsUnboundVariabilityType(); }
#line 3931 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 155: /* atomic_var_type_specifier: TOKEN_UINT8  */
#line 965 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsUnboundVariabilityType(); }
#line 3937 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 156: /* atomic_var_type_specifier: TOKEN_INT16  */
#line 966 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt16->GetAsUnboundVariabilityType(); }
#line 3943 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 157: /* atomic_var_type_specifier: TOKEN_UINT16  */
#line 967 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsUnboundVariabilityType(); }
#line 3949 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 158: /* atomic_var_type_specifier: TOKEN_INT  */
#line 968 "src/parse.yy"
                { (yyval.atomicType) = AtomicType::UniformInt32->GetAsUnboundVariabilityType(); }
#line 3955 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 159: /* atomic_var_type_specifier: TOKEN_UINT  */
#line 969 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsUnboundVariabilityType(); }
#line 3961 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 160: /* atomic_var_type_specifier: TOKEN_FLOAT  */
#line 970 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformFloat->GetAsUnboundVariabilityType(); }
#line 3967 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 161: /* atomic_var_type_specifier: TOKEN_DOUBLE  */
#line 971 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformDouble->GetAsUnboundVariabilityType(); }
#line 3973 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 162: /* atomic_var_type_specifier: TOKEN_INT64  */
#line 972 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt64->GetAsUnboundVariabilityType(); }
#line 3979 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 163: /* atomic_var_type_specifier: TOKEN_UINT64  */
#line 973 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsUnboundVariabilityType(); }
#line 3985 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 164: /* short_vec_specifier: atomic_var_type_specifier '<' int_constant '>'  */
#line 978 "src/parse.yy"
    {
        (yyval.type) = (yyvsp[-3].atomicType) ? new VectorType((yyvsp[-3].atomicType), (int32_t)(yyvsp[-1].intVal)) : NULL;
    }
#line 3993 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 165: /* struct_or_union_name: TOKEN_IDENTIFIER  */
#line 984 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 3999 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 166: /* struct_or_union_name: TOKEN_TYPE_NAME  */
#line 985 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4005 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 167: /* struct_or_union_and_name: struct_or_union struct_or_union_name  */
#line 990 "src/parse.yy"
      {
          const Type *st = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (st == NULL) {
              st = new UndefinedStructType((yyvsp[0].constCharPtr), Variability::Unbound, false, (yylsp[0]));
              m->symbolTable->AddType((yyvsp[0].constCharPtr), st, (yylsp[0]));
              (yyval.type) = st;
          }
          else {
              if (CastType<StructType>(st) == NULL &&
                  CastType<UndefinedStructType>(st) == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not a struct type! (%s)", (yyvsp[0].constCharPtr),
                        st->GetString().c_str());
                  (yyval.type) = NULL;
              }
              else
                  (yyval.type) = st;
         }
      }
#line 4028 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 169: /* struct_or_union_specifier: struct_or_union_and_name '{' struct_declaration_list '}'  */
#line 1013 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              const std::string &name = CastType<StructType>((yyvsp[-3].type)) ?
                  CastType<StructType>((yyvsp[-3].type))->GetStructName() :
                  CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
              StructType *st = new StructType(name, elementTypes, elementNames,
                                              elementPositions, false, Variability::Unbound, (yylsp[-3]));
              m->symbolTable->AddType(name.c_str(), st, (yylsp[-3]));
              (yyval.type) = st;
          }
          else
              (yyval.type) = NULL;
      }
#line 4051 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 170: /* struct_or_union_specifier: struct_or_union '{' struct_declaration_list '}'  */
#line 1032 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                                  false, Variability::Unbound, (yylsp[-3]));
          }
          else
              (yyval.type) = NULL;
      }
#line 4069 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 171: /* struct_or_union_specifier: struct_or_union '{' '}'  */
#line 1046 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                              false, Variability::Unbound, (yylsp[-2]));
      }
#line 4081 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 172: /* struct_or_union_specifier: struct_or_union_and_name '{' '}'  */
#line 1054 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          const std::string &name = CastType<StructType>((yyvsp[-2].type)) ?
              CastType<StructType>((yyvsp[-2].type))->GetStructName() :
              CastType<UndefinedStructType>((yyvsp[-2].type))->GetStructName();
          StructType *st = new StructType(name, elementTypes,
                                          elementNames, elementPositions,
                                          false, Variability::Unbound, (yylsp[-2]));
          m->symbolTable->AddType(name.c_str(), st, (yylsp[-1]));
          (yyval.type) = st;
      }
#line 4099 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 174: /* struct_declaration_list: struct_declaration  */
#line 1075 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = new std::vector<StructDeclaration *>;
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4110 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 175: /* struct_declaration_list: struct_declaration_list struct_declaration  */
#line 1082 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = (std::vector<StructDeclaration *> *)(yyvsp[-1].structDeclarationList);
          if (sdl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sdl = new std::vector<StructDeclaration *>;
          }
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4125 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 176: /* struct_declaration: specifier_qualifier_list struct_declarator_list ';'  */
#line 1096 "src/parse.yy"
      { (yyval.structDeclaration) = ((yyvsp[-2].type) != NULL && (yyvsp[-1].structDeclaratorList) != NULL) ? new StructDeclaration((yyvsp[-2].type), (yyvsp[-1].structDeclaratorList)) : NULL; }
#line 4131 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 180: /* specifier_qualifier_list: type_qualifier specifier_qualifier_list  */
#line 1104 "src/parse.yy"
    {
        if ((yyvsp[0].type) != NULL) {
            if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNIFORM) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VARYING) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_CONST)
                (yyval.type) = (yyvsp[0].type)->GetAsConstType();
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_SIGNED) {
                if ((yyvsp[0].type)->IsIntType() == false) {
                    Error((yylsp[-1]), "Can't apply \"signed\" qualifier to \"%s\" type.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNSIGNED) {
                const Type *t = (yyvsp[0].type)->GetAsUnsignedType();
                if (t)
                    (yyval.type) = t;
                else {
                    Error((yylsp[-1]), "Can't apply \"unsigned\" qualifier to \"%s\" type. Ignoring.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_INLINE) {
                Error((yylsp[-1]), "\"inline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_NOINLINE) {
                Error((yylsp[-1]), "\"noinline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VECTORCALL) {
                Error((yylsp[-1]), "\"__vectorcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_TASK) {
                Error((yylsp[-1]), "\"task\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNMASKED) {
                Error((yylsp[-1]), "\"unmasked\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_EXPORT) {
                Error((yylsp[-1]), "\"export\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else
                FATAL("Unhandled type qualifier in parser.");
        }
        else {
            if (m->errorCount == 0)
                Error((yylsp[-1]), "Lost type qualifier in parser.");
            (yyval.type) = NULL;
        }
    }
#line 4212 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 181: /* struct_declarator_list: struct_declarator  */
#line 1185 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4223 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 182: /* struct_declarator_list: struct_declarator_list ',' struct_declarator  */
#line 1192 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = (std::vector<Declarator *> *)(yyvsp[-2].structDeclaratorList);
          if (sdl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              sdl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4238 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 183: /* struct_declarator: declarator  */
#line 1205 "src/parse.yy"
                 { (yyval.declarator) = (yyvsp[0].declarator); }
#line 4244 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 184: /* enum_identifier: TOKEN_IDENTIFIER  */
#line 1213 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4250 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 185: /* enum_specifier: TOKEN_ENUM '{' enumerator_list '}'  */
#line 1217 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4258 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 186: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list '}'  */
#line 1221 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-3].constCharPtr), (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4266 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 187: /* enum_specifier: TOKEN_ENUM '{' enumerator_list ',' '}'  */
#line 1225 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4274 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 188: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list ',' '}'  */
#line 1229 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-4].constCharPtr), (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4282 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 189: /* enum_specifier: TOKEN_ENUM enum_identifier  */
#line 1233 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (type == NULL) {
              std::vector<std::string> alternates = m->symbolTable->ClosestEnumTypeMatch((yyvsp[0].constCharPtr));
              std::string alts = lGetAlternates(alternates);
              Error((yylsp[0]), "Enum type \"%s\" unknown.%s", (yyvsp[0].constCharPtr), alts.c_str());
              (yyval.enumType) = NULL;
          }
          else {
              const EnumType *enumType = CastType<EnumType>(type);
              if (enumType == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not an enum type (%s).", (yyvsp[0].constCharPtr),
                        type->GetString().c_str());
                  (yyval.enumType) = NULL;
              }
              else
                  (yyval.enumType) = enumType;
          }
      }
#line 4306 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 190: /* enumerator_list: enumerator  */
#line 1256 "src/parse.yy"
      {
          if ((yyvsp[0].symbol) == NULL)
              (yyval.symbolList) = NULL;
          else {
              std::vector<Symbol *> *el = new std::vector<Symbol *>;
              el->push_back((yyvsp[0].symbol));
              (yyval.symbolList) = el;
          }
      }
#line 4320 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 191: /* enumerator_list: enumerator_list ',' enumerator  */
#line 1266 "src/parse.yy"
      {
          std::vector<Symbol *> *symList = (yyvsp[-2].symbolList);
          if (symList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              symList = new std::vector<Symbol *>;
          }
          if ((yyvsp[0].symbol) != NULL)
              symList->push_back((yyvsp[0].symbol));
          (yyval.symbolList) = symList;
      }
#line 4335 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 192: /* enumerator: enum_identifier  */
#line 1280 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol((yyvsp[0].constCharPtr), (yylsp[0]));
      }
#line 4343 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 193: /* enumerator: enum_identifier '=' constant_expression  */
#line 1284 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].constCharPtr) != NULL && (yyvsp[0].expr) != NULL &&
              lGetConstantInt((yyvsp[0].expr), &value, (yylsp[0]), "Enumerator value")) {
              Symbol *sym = new Symbol((yyvsp[-2].constCharPtr), (yylsp[-2]));
              sym->constValue = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                                              (uint32_t)value, (yylsp[0]));
              (yyval.symbol) = sym;
          }
          else
              (yyval.symbol) = NULL;
      }
#line 4360 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 194: /* type_qualifier: TOKEN_CONST  */
#line 1299 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_CONST; }
#line 4366 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 195: /* type_qualifier: TOKEN_UNIFORM  */
#line 1300 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNIFORM; }
#line 4372 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 196: /* type_qualifier: TOKEN_VARYING  */
#line 1301 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_VARYING; }
#line 4378 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 197: /* type_qualifier: TOKEN_TASK  */
#line 1302 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_TASK; }
#line 4384 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 198: /* type_qualifier: TOKEN_UNMASKED  */
#line 1303 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNMASKED; }
#line 4390 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 199: /* type_qualifier: TOKEN_EXPORT  */
#line 1304 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_EXPORT; }
#line 4396 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 200: /* type_qualifier: TOKEN_INLINE  */
#line 1305 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_INLINE; }
#line 4402 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 201: /* type_qualifier: TOKEN_NOINLINE  */
#line 1306 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_NOINLINE; }
#line 4408 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 202: /* type_qualifier: TOKEN_VECTORCALL  */
#line 1307 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_VECTORCALL; }
#line 4414 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 203: /* type_qualifier: TOKEN_SIGNED  */
#line 1308 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_SIGNED; }
#line 4420 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 204: /* type_qualifier: TOKEN_UNSIGNED  */
#line 1309 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNSIGNED; }
#line 4426 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 205: /* type_qualifier_list: type_qualifier  */
#line 1314 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[0].typeQualifier);
    }
#line 4434 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 206: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 1318 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[-1].typeQualifier) | (yyvsp[0].typeQualifier);
    }
#line 4442 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 207: /* declarator: pointer direct_declarator  */
#line 1325 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4458 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 208: /* declarator: reference direct_declarator  */
#line 1337 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4474 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 210: /* int_constant: TOKEN_INT8_CONSTANT  */
#line 1352 "src/parse.yy"
                          { (yyval.intVal) = yylval.intVal; }
#line 4480 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 211: /* int_constant: TOKEN_INT16_CONSTANT  */
#line 1353 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4486 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 212: /* int_constant: TOKEN_INT32_CONSTANT  */
#line 1354 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4492 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 213: /* int_constant: TOKEN_INT64_CONSTANT  */
#line 1355 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4498 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 214: /* direct_declarator: TOKEN_IDENTIFIER  */
#line 1360 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
      }
#line 4508 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 215: /* direct_declarator: '(' declarator ')'  */
#line 1366 "src/parse.yy"
    {
        (yyval.declarator) = (yyvsp[-1].declarator);
    }
#line 4516 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 216: /* direct_declarator: direct_declarator '[' constant_expression ']'  */
#line 1370 "src/parse.yy"
    {
        int size;
        if ((yyvsp[-3].declarator) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                d->arraySize = size;
                d->child = (yyvsp[-3].declarator);
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4538 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 217: /* direct_declarator: direct_declarator '[' ']'  */
#line 1388 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
            d->arraySize = 0; // unsize
            d->child = (yyvsp[-2].declarator);
            (yyval.declarator) = d;
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4553 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 218: /* direct_declarator: direct_declarator '[' error ']'  */
#line 1399 "src/parse.yy"
    {
         (yyval.declarator) = NULL;
    }
#line 4561 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 219: /* direct_declarator: direct_declarator '(' parameter_type_list ')'  */
#line 1403 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL)
                  d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4577 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 220: /* direct_declarator: direct_declarator '(' ')'  */
#line 1415 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4591 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 221: /* direct_declarator: direct_declarator '(' error ')'  */
#line 1425 "src/parse.yy"
    {
        (yyval.declarator) = NULL;
    }
#line 4599 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 222: /* pointer: '*'  */
#line 1433 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_POINTER, (yylsp[0]));
    }
#line 4607 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 223: /* pointer: '*' type_qualifier_list  */
#line 1437 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[0].typeQualifier);
          (yyval.declarator) = d;
      }
#line 4617 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 224: /* pointer: '*' pointer  */
#line 1443 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 4627 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 225: /* pointer: '*' type_qualifier_list pointer  */
#line 1449 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-2]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[-1].typeQualifier);
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 4638 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 226: /* reference: '&'  */
#line 1460 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
    }
#line 4646 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 227: /* parameter_type_list: parameter_list  */
#line 1467 "src/parse.yy"
                     { (yyval.declarationList) = (yyvsp[0].declarationList); }
#line 4652 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 228: /* parameter_list: parameter_declaration  */
#line 1472 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 4663 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 229: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 1479 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = (std::vector<Declaration *> *)(yyvsp[-2].declarationList);
        if (dl == NULL)
            dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 4676 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 230: /* parameter_list: error ','  */
#line 1488 "src/parse.yy"
    {
        lSuggestParamListAlternates();
        (yyval.declarationList) = NULL;
    }
#line 4685 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 231: /* parameter_declaration: declaration_specifiers declarator  */
#line 1496 "src/parse.yy"
    {
        (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
    }
#line 4693 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 232: /* parameter_declaration: declaration_specifiers declarator '=' initializer  */
#line 1500 "src/parse.yy"
    {
        if ((yyvsp[-3].declSpecs) != NULL && (yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
            (yyval.declaration) = new Declaration((yyvsp[-3].declSpecs), (yyvsp[-2].declarator));
        }
        else
            (yyval.declaration) = NULL;
    }
#line 4706 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 233: /* parameter_declaration: declaration_specifiers abstract_declarator  */
#line 1509 "src/parse.yy"
    {
        if ((yyvsp[-1].declSpecs) != NULL && (yyvsp[0].declarator) != NULL)
            (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        else
            (yyval.declaration) = NULL;
    }
#line 4717 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 234: /* parameter_declaration: declaration_specifiers  */
#line 1516 "src/parse.yy"
    {
        if ((yyvsp[0].declSpecs) == NULL)
            (yyval.declaration) = NULL;
        else
            (yyval.declaration) = new Declaration((yyvsp[0].declSpecs));
    }
#line 4728 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 236: /* type_name: specifier_qualifier_list abstract_declarator  */
#line 1534 "src/parse.yy"
    {
        if ((yyvsp[-1].type) == NULL || (yyvsp[0].declarator) == NULL)
            (yyval.type) = NULL;
        else {
            (yyvsp[0].declarator)->InitFromType((yyvsp[-1].type), NULL);
            (yyval.type) = (yyvsp[0].declarator)->type;
        }
    }
#line 4741 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 237: /* abstract_declarator: pointer  */
#line 1546 "src/parse.yy"
      {
          (yyval.declarator) = (yyvsp[0].declarator);
      }
#line 4749 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 239: /* abstract_declarator: pointer direct_abstract_declarator  */
#line 1551 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4763 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 240: /* abstract_declarator: reference  */
#line 1561 "src/parse.yy"
      {
          (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
      }
#line 4771 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 241: /* abstract_declarator: reference direct_abstract_declarator  */
#line 1565 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_REFERENCE, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4785 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 242: /* direct_abstract_declarator: '(' abstract_declarator ')'  */
#line 1578 "src/parse.yy"
      { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 4791 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 243: /* direct_abstract_declarator: '[' ']'  */
#line 1580 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-1]), (yylsp[0])));
          d->arraySize = 0;
          (yyval.declarator) = d;
      }
#line 4801 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 244: /* direct_abstract_declarator: '[' constant_expression ']'  */
#line 1586 "src/parse.yy"
      {
        int size;
        if ((yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                d->arraySize = size;
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
      }
#line 4822 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 245: /* direct_abstract_declarator: direct_abstract_declarator '[' ']'  */
#line 1603 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
              d->arraySize = 0;
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4837 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 246: /* direct_abstract_declarator: direct_abstract_declarator '[' constant_expression ']'  */
#line 1614 "src/parse.yy"
      {
          int size;
          if ((yyvsp[-3].declarator) != NULL && (yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
              if (size < 0) {
                  Error((yylsp[-1]), "Array dimension must be non-negative.");
                  (yyval.declarator) = NULL;
              }
              else {
                  Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                  d->arraySize = size;
                  d->child = (yyvsp[-3].declarator);
                  (yyval.declarator) = d;
              }
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4859 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 247: /* direct_abstract_declarator: '(' ')'  */
#line 1632 "src/parse.yy"
      { (yyval.declarator) = new Declarator(DK_FUNCTION, Union((yylsp[-1]), (yylsp[0]))); }
#line 4865 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 248: /* direct_abstract_declarator: '(' parameter_type_list ')'  */
#line 1634 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
          if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
          (yyval.declarator) = d;
      }
#line 4875 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 249: /* direct_abstract_declarator: direct_abstract_declarator '(' ')'  */
#line 1640 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4889 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 250: /* direct_abstract_declarator: direct_abstract_declarator '(' parameter_type_list ')'  */
#line 1650 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
      }
#line 4904 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 252: /* initializer: '{' initializer_list '}'  */
#line 1664 "src/parse.yy"
                               { (yyval.expr) = (yyvsp[-1].exprList); }
#line 4910 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 253: /* initializer: '{' initializer_list ',' '}'  */
#line 1665 "src/parse.yy"
                                   { (yyval.expr) = (yyvsp[-2].exprList); }
#line 4916 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 254: /* initializer_list: initializer  */
#line 1670 "src/parse.yy"
      { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 4922 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 255: /* initializer_list: initializer_list ',' initializer  */
#line 1672 "src/parse.yy"
      {
          ExprList *exprList = (yyvsp[-2].exprList);
          if (exprList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              exprList = new ExprList((yylsp[0]));
          }
          exprList->exprs.push_back((yyvsp[0].expr));
          exprList->pos = Union(exprList->pos, (yylsp[0]));
          (yyval.exprList) = exprList;
      }
#line 4937 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 256: /* pragma: TOKEN_PRAGMA  */
#line 1686 "src/parse.yy"
    {
        (yyval.pragmaAttributes) = (yylval.pragmaAttributes);
    }
#line 4945 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 257: /* attributed_statement: pragma attributed_statement  */
#line 1693 "src/parse.yy"
    {
        if (((yyvsp[-1].pragmaAttributes)->aType == PragmaAttributes::AttributeType::pragmaloop) && ((yyvsp[0].stmt) != NULL)) {
            std::pair<Globals::pragmaUnrollType, int> unrollVal = std::pair<Globals::pragmaUnrollType, int>((yyvsp[-1].pragmaAttributes)->unrollType, (yyvsp[-1].pragmaAttributes)->count);
            (yyvsp[0].stmt)->SetLoopAttribute(unrollVal);
        }
        (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 4957 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 271: /* statement: error ';'  */
#line 1717 "src/parse.yy"
    {
        lSuggestBuiltinAlternates();
        (yyval.stmt) = NULL;
    }
#line 4966 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 272: /* labeled_statement: goto_identifier ':' attributed_statement  */
#line 1725 "src/parse.yy"
    {
        (yyval.stmt) = new LabeledStmt((yyvsp[-2].constCharPtr), (yyvsp[0].stmt), (yylsp[-2]));
    }
#line 4974 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 273: /* labeled_statement: TOKEN_CASE constant_expression ':' attributed_statement  */
#line 1729 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].expr) != NULL &&
              lGetConstantInt((yyvsp[-2].expr), &value, (yylsp[-2]), "Case statement value")) {
              (yyval.stmt) = new CaseStmt(value, (yyvsp[0].stmt), Union((yylsp[-3]), (yylsp[-2])));
          }
          else
              (yyval.stmt) = NULL;
      }
#line 4988 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 274: /* labeled_statement: TOKEN_DEFAULT ':' attributed_statement  */
#line 1739 "src/parse.yy"
      { (yyval.stmt) = new DefaultStmt((yyvsp[0].stmt), (yylsp[-2])); }
#line 4994 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 275: /* start_scope: '{'  */
#line 1743 "src/parse.yy"
          { m->symbolTable->PushScope(); }
#line 5000 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 276: /* end_scope: '}'  */
#line 1747 "src/parse.yy"
          { m->symbolTable->PopScope(); }
#line 5006 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 277: /* compound_statement: '{' '}'  */
#line 1751 "src/parse.yy"
              { (yyval.stmt) = NULL; }
#line 5012 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 278: /* compound_statement: start_scope statement_list end_scope  */
#line 1752 "src/parse.yy"
                                           { (yyval.stmt) = (yyvsp[-1].stmt); }
#line 5018 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 279: /* statement_list: attributed_statement  */
#line 1757 "src/parse.yy"
      {
          StmtList *sl = new StmtList((yylsp[0]));
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5028 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 280: /* statement_list: statement_list attributed_statement  */
#line 1763 "src/parse.yy"
      {
          StmtList *sl = (StmtList *)(yyvsp[-1].stmt);
          if (sl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sl = new StmtList((yylsp[0]));
          }
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5042 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 281: /* expression_statement: ';'  */
#line 1775 "src/parse.yy"
          { (yyval.stmt) = NULL; }
#line 5048 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 282: /* expression_statement: expression ';'  */
#line 1776 "src/parse.yy"
                     { (yyval.stmt) = (yyvsp[-1].expr) ? new ExprStmt((yyvsp[-1].expr), (yylsp[-1])) : NULL; }
#line 5054 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 283: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement  */
#line 1781 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, false, (yylsp[-4])); }
#line 5060 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 284: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 1783 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), false, (yylsp[-6])); }
#line 5066 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 285: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement  */
#line 1785 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, true, (yylsp[-4])); }
#line 5072 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 286: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 1787 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), true, (yylsp[-6])); }
#line 5078 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 287: /* selection_statement: TOKEN_SWITCH '(' expression ')' attributed_statement  */
#line 1789 "src/parse.yy"
      { (yyval.stmt) = new SwitchStmt((yyvsp[-2].expr), (yyvsp[0].stmt), (yylsp[-4])); }
#line 5084 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 288: /* for_test: ';'  */
#line 1794 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 5090 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 289: /* for_test: expression ';'  */
#line 1796 "src/parse.yy"
      { (yyval.expr) = (yyvsp[-1].expr); }
#line 5096 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 292: /* for_scope: TOKEN_FOR  */
#line 1805 "src/parse.yy"
                { m->symbolTable->PushScope(); }
#line 5102 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 293: /* cfor_scope: TOKEN_CFOR  */
#line 1809 "src/parse.yy"
                 { m->symbolTable->PushScope(); }
#line 5108 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 294: /* foreach_scope: TOKEN_FOREACH  */
#line 1813 "src/parse.yy"
                    { m->symbolTable->PushScope(); }
#line 5114 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 295: /* foreach_tiled_scope: TOKEN_FOREACH_TILED  */
#line 1817 "src/parse.yy"
                          { m->symbolTable->PushScope(); }
#line 5120 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 296: /* foreach_identifier: TOKEN_IDENTIFIER  */
#line 1822 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::VaryingInt32->GetAsConstType());
    }
#line 5128 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 297: /* foreach_active_scope: TOKEN_FOREACH_ACTIVE  */
#line 1828 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5134 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 298: /* foreach_active_identifier: TOKEN_IDENTIFIER  */
#line 1833 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::UniformInt64->GetAsConstType());
    }
#line 5142 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 299: /* integer_dotdotdot: TOKEN_INT32DOTDOTDOT_CONSTANT  */
#line 1839 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 5151 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 300: /* integer_dotdotdot: TOKEN_UINT32DOTDOTDOT_CONSTANT  */
#line 1843 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 5160 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 301: /* integer_dotdotdot: TOKEN_INT64DOTDOTDOT_CONSTANT  */
#line 1847 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 5169 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 302: /* integer_dotdotdot: TOKEN_UINT64DOTDOTDOT_CONSTANT  */
#line 1851 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 5178 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 303: /* foreach_dimension_specifier: foreach_identifier '=' assignment_expression TOKEN_DOTDOTDOT assignment_expression  */
#line 1859 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-4].symbol), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 5186 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 304: /* foreach_dimension_specifier: foreach_identifier '=' integer_dotdotdot assignment_expression  */
#line 1863 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-3].symbol), (yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 5194 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 305: /* foreach_dimension_list: foreach_dimension_specifier  */
#line 1870 "src/parse.yy"
    {
        (yyval.foreachDimensionList) = new std::vector<ForeachDimension *>;
        (yyval.foreachDimensionList)->push_back((yyvsp[0].foreachDimension));
    }
#line 5203 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 306: /* foreach_dimension_list: foreach_dimension_list ',' foreach_dimension_specifier  */
#line 1875 "src/parse.yy"
    {
        std::vector<ForeachDimension *> *dv = (yyvsp[-2].foreachDimensionList);
        if (dv == NULL) {
            AssertPos((yylsp[-2]), m->errorCount > 0);
            dv = new std::vector<ForeachDimension *>;
        }
        if ((yyvsp[0].foreachDimension) != NULL)
            dv->push_back((yyvsp[0].foreachDimension));
        (yyval.foreachDimensionList) = dv;
    }
#line 5218 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 307: /* foreach_unique_scope: TOKEN_FOREACH_UNIQUE  */
#line 1888 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5224 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 308: /* foreach_unique_identifier: TOKEN_IDENTIFIER  */
#line 1892 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5230 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 309: /* iteration_statement: TOKEN_WHILE '(' expression ')' attributed_statement  */
#line 1897 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-4])); }
#line 5236 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 310: /* iteration_statement: TOKEN_CWHILE '(' expression ')' attributed_statement  */
#line 1899 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-4])); }
#line 5242 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 311: /* iteration_statement: TOKEN_DO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 1901 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), false, (yylsp[-6])); }
#line 5248 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 312: /* iteration_statement: TOKEN_CDO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 1903 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), true, (yylsp[-6])); }
#line 5254 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 313: /* iteration_statement: for_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 1905 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5262 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 314: /* iteration_statement: for_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 1909 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), false, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5270 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 315: /* iteration_statement: cfor_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 1913 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5278 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 316: /* iteration_statement: cfor_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 1917 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), true, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5286 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 317: /* $@1: %empty  */
#line 1921 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }
         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5300 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 318: /* iteration_statement: foreach_scope '(' foreach_dimension_list ')' $@1 attributed_statement  */
#line 1931 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-3]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), false, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5322 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 319: /* $@2: %empty  */
#line 1949 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5337 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 320: /* iteration_statement: foreach_tiled_scope '(' foreach_dimension_list ')' $@2 attributed_statement  */
#line 1960 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-5]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), true, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5359 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 321: /* $@3: %empty  */
#line 1978 "src/parse.yy"
     {
         if ((yyvsp[-1].symbol) != NULL)
             m->symbolTable->AddVariable((yyvsp[-1].symbol));
     }
#line 5368 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 322: /* iteration_statement: foreach_active_scope '(' foreach_active_identifier ')' $@3 attributed_statement  */
#line 1983 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachActiveStmt((yyvsp[-3].symbol), (yyvsp[0].stmt), Union((yylsp[-5]), (yylsp[-2])));
         m->symbolTable->PopScope();
     }
#line 5377 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 323: /* $@4: %empty  */
#line 1989 "src/parse.yy"
     {
         Expr *expr = (yyvsp[-1].expr);
         const Type *type;
         if (expr != NULL &&
             (expr = TypeCheck(expr)) != NULL &&
             (type = expr->GetType()) != NULL) {
             const Type *iterType = type->GetAsUniformType()->GetAsConstType();
             Symbol *sym = new Symbol((yyvsp[-3].constCharPtr), (yylsp[-3]), iterType);
             m->symbolTable->AddVariable(sym);
         }
     }
#line 5393 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 324: /* iteration_statement: foreach_unique_scope '(' foreach_unique_identifier TOKEN_IN expression ')' $@4 attributed_statement  */
#line 2001 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachUniqueStmt((yyvsp[-5].constCharPtr), (yyvsp[-3].expr), (yyvsp[0].stmt), (yylsp[-7]));
         m->symbolTable->PopScope();
     }
#line 5402 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 325: /* goto_identifier: TOKEN_IDENTIFIER  */
#line 2008 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5408 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 326: /* jump_statement: TOKEN_GOTO goto_identifier ';'  */
#line 2013 "src/parse.yy"
      { (yyval.stmt) = new GotoStmt((yyvsp[-1].constCharPtr), (yylsp[-2]), (yylsp[-1])); }
#line 5414 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 327: /* jump_statement: TOKEN_CONTINUE ';'  */
#line 2015 "src/parse.yy"
      { (yyval.stmt) = new ContinueStmt((yylsp[-1])); }
#line 5420 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 328: /* jump_statement: TOKEN_BREAK ';'  */
#line 2017 "src/parse.yy"
      { (yyval.stmt) = new BreakStmt((yylsp[-1])); }
#line 5426 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 329: /* jump_statement: TOKEN_RETURN ';'  */
#line 2019 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt(NULL, (yylsp[-1])); }
#line 5432 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 330: /* jump_statement: TOKEN_RETURN expression ';'  */
#line 2021 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt((yyvsp[-1].expr), (yylsp[-2])); }
#line 5438 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 331: /* sync_statement: TOKEN_SYNC ';'  */
#line 2026 "src/parse.yy"
      { (yyval.stmt) = new ExprStmt(new SyncExpr((yylsp[-1])), (yylsp[-1])); }
#line 5444 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 332: /* delete_statement: TOKEN_DELETE expression ';'  */
#line 2031 "src/parse.yy"
    {
        (yyval.stmt) = new DeleteStmt((yyvsp[-1].expr), Union((yylsp[-2]), (yylsp[-1])));
    }
#line 5452 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 333: /* unmasked_statement: TOKEN_UNMASKED '{' statement_list '}'  */
#line 2038 "src/parse.yy"
    {
        (yyval.stmt) = new UnmaskedStmt((yyvsp[-1].stmt), (yylsp[-3]));
    }
#line 5460 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 334: /* print_statement: TOKEN_PRINT '(' string_constant ')' ';'  */
#line 2045 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-2].stringVal), NULL, (yylsp[-4]));
      }
#line 5468 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 335: /* print_statement: TOKEN_PRINT '(' string_constant ',' argument_expression_list ')' ';'  */
#line 2049 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].exprList), (yylsp[-6]));
      }
#line 5476 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 336: /* assert_statement: TOKEN_ASSERT '(' string_constant ',' expression ')' ';'  */
#line 2056 "src/parse.yy"
      {
          (yyval.stmt) = new AssertStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].expr), (yylsp[-6]));
      }
#line 5484 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 342: /* external_declaration: TOKEN_EXPORT '{' type_specifier_list '}' ';'  */
#line 2071 "src/parse.yy"
    {
        if ((yyvsp[-2].typeList) != NULL)
            m->AddExportedTypes(*(yyvsp[-2].typeList));
    }
#line 5493 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 343: /* external_declaration: declaration  */
#line 2076 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) != NULL)
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i)
                lAddDeclaration((yyvsp[0].declaration)->declSpecs, (yyvsp[0].declaration)->declarators[i]);
    }
#line 5503 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 345: /* $@5: %empty  */
#line 2086 "src/parse.yy"
    {
        lAddDeclaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        lAddFunctionParams((yyvsp[0].declarator));
        lAddMaskToSymbolTable((yylsp[0]));
        if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK)
            lAddThreadIndexCountToSymbolTable((yylsp[0]));
    }
#line 5515 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;

  case 346: /* function_definition: declaration_specifiers declarator $@5 compound_statement  */
#line 2094 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->InitFromDeclSpecs((yyvsp[-3].declSpecs));
            const FunctionType *funcType = CastType<FunctionType>((yyvsp[-2].declarator)->type);
            if (funcType == NULL)
                AssertPos((yylsp[-3]), m->errorCount > 0);
            else if ((yyvsp[-3].declSpecs)->storageClass == SC_TYPEDEF)
                Error((yylsp[-3]), "Illegal \"typedef\" provided with function definition.");
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == NULL) code = new StmtList((yylsp[0]));
                m->AddFunctionDefinition((yyvsp[-2].declarator)->name, funcType, code);
            }
        }
        m->symbolTable->PopScope(); // push in lAddFunctionParams();
    }
#line 5536 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"
    break;


#line 5540 "/usr/src/RPM/BUILD/ispc-1.15.0/i586-alt-linux/./parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2120 "src/parse.yy"



void yyerror(const char *s) {
    if (strlen(yytext) == 0)
        Error(yylloc, "Premature end of file: %s.", s);
    else
        Error(yylloc, "%s.", s);
}


static int
lYYTNameErr (char *yyres, const char *yystr)
{
  extern std::map<std::string, std::string> tokenNameRemap;
  Assert(tokenNameRemap.size() > 0);
  if (tokenNameRemap.find(yystr) != tokenNameRemap.end()) {
      std::string n = tokenNameRemap[yystr];
      if (yyres == NULL)
          return n.size();
      else
          return yystpcpy(yyres, n.c_str()) - yyres;
  }

  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}

static void
lSuggestBuiltinAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lBuiltinTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
         Error(yylloc, "%s", alts.c_str());
}


static void
lSuggestParamListAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lParamListTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
        Error(yylloc, "%s", alts.c_str());
}


static void
lAddDeclaration(DeclSpecs *ds, Declarator *decl) {
    if (ds == NULL || decl == NULL)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass == SC_TYPEDEF)
        m->AddTypeDef(decl->name, decl->type, decl->pos);
    else {
        if (decl->type == NULL) {
            Assert(m->errorCount > 0);
            return;
        }

        decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != NULL) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
            m->AddFunctionDeclaration(decl->name, ft, ds->storageClass,
                                      isInline, isNoInline, isVectorCall, decl->pos);
        }
        else {
            bool isConst = (ds->typeQualifiers & TYPEQUAL_CONST) != 0;
            m->AddGlobalVariable(decl->name, decl->type, decl->initExpr,
                                 isConst, decl->storageClass, decl->pos);
        }
    }
}


/** We're about to start parsing the body of a function; add all of the
    parameters to the symbol table so that they're available.
*/
static void
lAddFunctionParams(Declarator *decl) {
    m->symbolTable->PushScope();

    if (decl == NULL) {
        return;
    }

    // walk down to the declarator for the function itself
    while (decl->kind != DK_FUNCTION && decl->child != NULL)
        decl = decl->child;
    if (decl->kind != DK_FUNCTION) {
        AssertPos(decl->pos, m->errorCount > 0);
        return;
    }

    // now loop over its parameters and add them to the symbol table
    for (unsigned int i = 0; i < decl->functionParams.size(); ++i) {
        Declaration *pdecl = decl->functionParams[i];
        Assert(pdecl != NULL && pdecl->declarators.size() == 1);
        Declarator *declarator = pdecl->declarators[0];
        if (declarator == NULL)
            AssertPos(decl->pos, m->errorCount > 0);
        else {
            Symbol *sym = new Symbol(declarator->name, declarator->pos,
                                     declarator->type, declarator->storageClass);
#ifndef NDEBUG
            bool ok = m->symbolTable->AddVariable(sym);
            if (ok == false)
                AssertPos(decl->pos, m->errorCount > 0);
#else
            m->symbolTable->AddVariable(sym);
#endif
        }
    }

    // The corresponding pop scope happens in function_definition rules
    // above...
}


/** Add a symbol for the built-in mask variable to the symbol table */
static void lAddMaskToSymbolTable(SourcePos pos) {
    const Type *t = NULL;
    switch (g->target->getMaskBitCount()) {
    case 1:
        t = AtomicType::VaryingBool;
        break;
    case 8:
        t = AtomicType::VaryingUInt8;
        break;
    case 16:
        t = AtomicType::VaryingUInt16;
        break;
    case 32:
        t = AtomicType::VaryingUInt32;
        break;
    case 64:
        t = AtomicType::VaryingUInt64;
        break;
    default:
        FATAL("Unhandled mask bitsize in lAddMaskToSymbolTable");
    }

    t = t->GetAsConstType();
    Symbol *maskSymbol = new Symbol("__mask", pos, t);
    m->symbolTable->AddVariable(maskSymbol);
}


/** Add the thread index and thread count variables to the symbol table
    (this should only be done for 'task'-qualified functions. */
static void lAddThreadIndexCountToSymbolTable(SourcePos pos) {
    const Type *type = AtomicType::UniformUInt32->GetAsConstType();

    Symbol *threadIndexSym = new Symbol("threadIndex", pos, type);
    m->symbolTable->AddVariable(threadIndexSym);

    Symbol *threadCountSym = new Symbol("threadCount", pos, type);
    m->symbolTable->AddVariable(threadCountSym);

    Symbol *taskIndexSym = new Symbol("taskIndex", pos, type);
    m->symbolTable->AddVariable(taskIndexSym);
    
    Symbol *taskCountSym = new Symbol("taskCount", pos, type);
    m->symbolTable->AddVariable(taskCountSym);
    
    Symbol *taskIndexSym0 = new Symbol("taskIndex0", pos, type);
    m->symbolTable->AddVariable(taskIndexSym0);
    Symbol *taskIndexSym1 = new Symbol("taskIndex1", pos, type);
    m->symbolTable->AddVariable(taskIndexSym1);
    Symbol *taskIndexSym2 = new Symbol("taskIndex2", pos, type);
    m->symbolTable->AddVariable(taskIndexSym2);

    
    Symbol *taskCountSym0 = new Symbol("taskCount0", pos, type);
    m->symbolTable->AddVariable(taskCountSym0);
    Symbol *taskCountSym1 = new Symbol("taskCount1", pos, type);
    m->symbolTable->AddVariable(taskCountSym1);
    Symbol *taskCountSym2 = new Symbol("taskCount2", pos, type);
    m->symbolTable->AddVariable(taskCountSym2);
}


/** Small utility routine to construct a string for error messages that
    suggests alternate tokens for possibly-misspelled ones... */
static std::string lGetAlternates(std::vector<std::string> &alternates) {
    std::string alts;
    if (alternates.size()) {
        alts += " Did you mean ";
        for (unsigned int i = 0; i < alternates.size(); ++i) {
            alts += std::string("\"") + alternates[i] + std::string("\"");
            if (i < alternates.size() - 1) alts += ", or ";
        }
        alts += "?";
    }
    return alts;
}

static const char *
lGetStorageClassString(StorageClass sc) {
    switch (sc) {
    case SC_NONE:
        return "";
    case SC_EXTERN:
        return "extern";
    case SC_STATIC:
        return "static";
    case SC_TYPEDEF:
        return "typedef";
    case SC_EXTERN_C:
        return "extern \"C\"";
    default:
        Assert(!"logic error in lGetStorageClassString()");
        return "";
    }
}


/** Given an expression, see if it is equal to a compile-time constant
    integer value.  If so, return true and return the value in *value.
    If the expression isn't a compile-time constant or isn't an integer
    type, return false.
*/
static bool
lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage) {
    if (expr == NULL)
        return false;
    expr = TypeCheck(expr);
    if (expr == NULL)
        return false;
    expr = Optimize(expr);
    if (expr == NULL)
        return false;

    std::pair<llvm::Constant *, bool> cValPair = expr->GetConstant(expr->GetType());
    llvm::Constant *cval = cValPair.first;
    if (cval == NULL) {
        Error(pos, "%s must be a compile-time constant.", usage);
        return false;
    }
    else {
        llvm::ConstantInt *ci = llvm::dyn_cast<llvm::ConstantInt>(cval);
        if (ci == NULL) {
            Error(pos, "%s must be a compile-time integer constant.", usage);
            return false;
        }
        if ((int64_t)((int32_t)ci->getSExtValue()) != ci->getSExtValue()) {
            Error(pos, "%s must be representable with a 32-bit integer.", usage);
            return false;
        }
        const Type *type = expr->GetType();
        if (type->IsUnsignedType())
            *value = (int)ci->getZExtValue();
        else
            *value = (int)ci->getSExtValue();
        return true;
    }
}


static EnumType *
lCreateEnumType(const char *name, std::vector<Symbol *> *enums, SourcePos pos) {
    if (enums == NULL)
        return NULL;

    EnumType *enumType = name ? new EnumType(name, pos) : new EnumType(pos);
    if (name != NULL)
        m->symbolTable->AddType(name, enumType, pos);

    lFinalizeEnumeratorSymbols(*enums, enumType);
    for (unsigned int i = 0; i < enums->size(); ++i)
        m->symbolTable->AddVariable((*enums)[i]);
    enumType->SetEnumerators(*enums);
    return enumType;
}


/** Given an array of enumerator symbols, make sure each of them has a
    ConstExpr * in their Symbol::constValue member that stores their
    unsigned integer value.  Symbols that had values explicitly provided
    in the source file will already have ConstExpr * set; we just need
    to set the values for the others here.
*/
static void
lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                           const EnumType *enumType) {
    enumType = enumType->GetAsConstType();
    enumType = enumType->GetAsUniformType();

    /* nextVal tracks the value for the next enumerant.  It starts from
       zero and goes up with each successive enumerant.  If any of them
       has a value specified, then nextVal is ignored for that one and is
       set to one plus that one's value for the default value for the next
       one. */
    uint32_t nextVal = 0;

    for (unsigned int i = 0; i < enums.size(); ++i) {
        enums[i]->type = enumType;
        if (enums[i]->constValue != NULL) {
            /* Already has a value, so first update nextVal with it. */
            int count = enums[i]->constValue->GetValues(&nextVal);
            AssertPos(enums[i]->pos, count == 1);
            ++nextVal;

            /* When the source file as being parsed, the ConstExpr for any
               enumerant with a specified value was set to have unsigned
               int32 type, since we haven't created the parent EnumType
               by then.  Therefore, add a little type cast from uint32 to
               the actual enum type here and optimize it, which will have
               us end up with a ConstExpr with the desired EnumType... */
            Expr *castExpr = new TypeCastExpr(enumType, enums[i]->constValue,
                                              enums[i]->pos);
            castExpr = Optimize(castExpr);
            enums[i]->constValue = llvm::dyn_cast<ConstExpr>(castExpr);
            AssertPos(enums[i]->pos, enums[i]->constValue != NULL);
        }
        else {
            enums[i]->constValue = new ConstExpr(enumType, nextVal++,
                                                 enums[i]->pos);
        }
    }
}
